(set-logic QF-UFLIA)


(declare-sort Loc)
(declare-sort Set)
(declare-sort MSet)

(declare-fun singleton (Int) Set)
(declare-fun union (Set Set) Set)
(declare-fun inter (Set Set) Set)
(declare-fun minus (Set Set) Set)
(declare-fun emptyset () Set)
(declare-fun in (Int Set) Bool)
(declare-fun subset (Set Set) Bool)
(declare-fun leq (Set Set) Bool)
(declare-fun eq (Set Set) Bool)

(declare-fun msingleton (Int) MSet)
(declare-fun munion (MSet MSet) MSet)
(declare-fun minter (MSet MSet) MSet)
(declare-fun mminus (MSet MSet) MSet)
(declare-fun emptymset () MSet)
(declare-fun msubset (MSet MSet) Bool)
(declare-fun mleq (MSet MSet) Bool)
(declare-fun meq (MSet MSet) Bool)

(declare-fun count (MSet Int) Int)


(declare-fun nil () Loc)
(declare-fun key (Loc) Int)
(declare-fun order (Loc) Int)
(declare-fun order' (Loc) Int)
(declare-fun sibling (Loc) Loc)
(declare-fun sibling' (Loc) Loc)
(declare-fun children (Loc) Loc)
(declare-fun children' (Loc) Loc)

(declare-fun binomial-heap (Loc) Bool)
(declare-fun binomial-heap' (Loc) Bool)
(declare-fun binomial-tree (Loc) Bool)
(declare-fun binomial-tree' (Loc) Bool)
(declare-fun full-list (Loc) Bool)
(declare-fun full-list' (Loc) Bool)
(declare-fun keys (Loc) MSet)
(declare-fun keys' (Loc) MSet)

(assert (binomial-heap nil))
(assert (binomial-heap' nil))
(assert (not (binomial-tree nil)))
(assert (not (binomial-tree' nil)))
(assert (full-list nil))
(assert (full-list' nil))
(assert (meq (keys nil) emptymset))
(assert (meq (keys' nil) emptymset))
(assert (= (order nil) -1))
(assert (= (order' nil) -1))



; Vars
(declare-fun x () Loc)
(declare-fun y () Loc)
(declare-fun w1 () Int)
(declare-fun w2 () Int)











(assert (not (in w1 emptyset)))
(assert (not (in w2 emptyset)))
(assert (not (in (+ (order (children x)) 1) emptyset)))
(assert (not (in (+ (order (children y)) 1) emptyset)))
(assert (not (in (+ (order x) 1) emptyset)))
(assert (not (in (+ (order y) 1) emptyset)))
(assert (not (in (key x) emptyset)))
(assert (not (in (key y) emptyset)))
(assert (not (in (order nil) emptyset)))
(assert (not (in (order x) emptyset)))
(assert (not (in (order y) emptyset)))
(assert (not (in (order (sibling x)) emptyset)))
(assert (not (in (order (sibling y)) emptyset)))
(assert (not (in (order (children x)) emptyset)))
(assert (not (in (order (children y)) emptyset)))
(assert (not (in (order' nil) emptyset)))

(assert (= (count (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x))) w1) (+ (count (munion (msingleton (key x)) (keys (children x))) w1) (count (keys (sibling x)) w1))))
(assert (= (count (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x))) w2) (+ (count (munion (msingleton (key x)) (keys (children x))) w2) (count (keys (sibling x)) w2))))
(assert (= (count (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x))) (+ (order (children x)) 1)) (+ (count (munion (msingleton (key x)) (keys (children x))) (+ (order (children x)) 1)) (count (keys (sibling x)) (+ (order (children x)) 1)))))
(assert (= (count (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x))) (+ (order (children y)) 1)) (+ (count (munion (msingleton (key x)) (keys (children x))) (+ (order (children y)) 1)) (count (keys (sibling x)) (+ (order (children y)) 1)))))
(assert (= (count (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x))) (+ (order x) 1)) (+ (count (munion (msingleton (key x)) (keys (children x))) (+ (order x) 1)) (count (keys (sibling x)) (+ (order x) 1)))))
(assert (= (count (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x))) (+ (order y) 1)) (+ (count (munion (msingleton (key x)) (keys (children x))) (+ (order y) 1)) (count (keys (sibling x)) (+ (order y) 1)))))
(assert (= (count (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x))) (key x)) (+ (count (munion (msingleton (key x)) (keys (children x))) (key x)) (count (keys (sibling x)) (key x)))))
(assert (= (count (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x))) (key y)) (+ (count (munion (msingleton (key x)) (keys (children x))) (key y)) (count (keys (sibling x)) (key y)))))
(assert (= (count (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x))) (order nil)) (+ (count (munion (msingleton (key x)) (keys (children x))) (order nil)) (count (keys (sibling x)) (order nil)))))
(assert (= (count (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x))) (order x)) (+ (count (munion (msingleton (key x)) (keys (children x))) (order x)) (count (keys (sibling x)) (order x)))))
(assert (= (count (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x))) (order y)) (+ (count (munion (msingleton (key x)) (keys (children x))) (order y)) (count (keys (sibling x)) (order y)))))
(assert (= (count (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x))) (order (sibling x))) (+ (count (munion (msingleton (key x)) (keys (children x))) (order (sibling x))) (count (keys (sibling x)) (order (sibling x))))))
(assert (= (count (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x))) (order (sibling y))) (+ (count (munion (msingleton (key x)) (keys (children x))) (order (sibling y))) (count (keys (sibling x)) (order (sibling y))))))
(assert (= (count (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x))) (order (children x))) (+ (count (munion (msingleton (key x)) (keys (children x))) (order (children x))) (count (keys (sibling x)) (order (children x))))))
(assert (= (count (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x))) (order (children y))) (+ (count (munion (msingleton (key x)) (keys (children x))) (order (children y))) (count (keys (sibling x)) (order (children y))))))
(assert (= (count (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x))) (order' nil)) (+ (count (munion (msingleton (key x)) (keys (children x))) (order' nil)) (count (keys (sibling x)) (order' nil)))))
(assert (= (count (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y))) w1) (+ (count (munion (msingleton (key y)) (keys (children y))) w1) (count (keys (sibling y)) w1))))
(assert (= (count (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y))) w2) (+ (count (munion (msingleton (key y)) (keys (children y))) w2) (count (keys (sibling y)) w2))))
(assert (= (count (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y))) (+ (order (children x)) 1)) (+ (count (munion (msingleton (key y)) (keys (children y))) (+ (order (children x)) 1)) (count (keys (sibling y)) (+ (order (children x)) 1)))))
(assert (= (count (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y))) (+ (order (children y)) 1)) (+ (count (munion (msingleton (key y)) (keys (children y))) (+ (order (children y)) 1)) (count (keys (sibling y)) (+ (order (children y)) 1)))))
(assert (= (count (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y))) (+ (order x) 1)) (+ (count (munion (msingleton (key y)) (keys (children y))) (+ (order x) 1)) (count (keys (sibling y)) (+ (order x) 1)))))
(assert (= (count (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y))) (+ (order y) 1)) (+ (count (munion (msingleton (key y)) (keys (children y))) (+ (order y) 1)) (count (keys (sibling y)) (+ (order y) 1)))))
(assert (= (count (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y))) (key x)) (+ (count (munion (msingleton (key y)) (keys (children y))) (key x)) (count (keys (sibling y)) (key x)))))
(assert (= (count (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y))) (key y)) (+ (count (munion (msingleton (key y)) (keys (children y))) (key y)) (count (keys (sibling y)) (key y)))))
(assert (= (count (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y))) (order nil)) (+ (count (munion (msingleton (key y)) (keys (children y))) (order nil)) (count (keys (sibling y)) (order nil)))))
(assert (= (count (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y))) (order x)) (+ (count (munion (msingleton (key y)) (keys (children y))) (order x)) (count (keys (sibling y)) (order x)))))
(assert (= (count (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y))) (order y)) (+ (count (munion (msingleton (key y)) (keys (children y))) (order y)) (count (keys (sibling y)) (order y)))))
(assert (= (count (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y))) (order (sibling x))) (+ (count (munion (msingleton (key y)) (keys (children y))) (order (sibling x))) (count (keys (sibling y)) (order (sibling x))))))
(assert (= (count (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y))) (order (sibling y))) (+ (count (munion (msingleton (key y)) (keys (children y))) (order (sibling y))) (count (keys (sibling y)) (order (sibling y))))))
(assert (= (count (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y))) (order (children x))) (+ (count (munion (msingleton (key y)) (keys (children y))) (order (children x))) (count (keys (sibling y)) (order (children x))))))
(assert (= (count (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y))) (order (children y))) (+ (count (munion (msingleton (key y)) (keys (children y))) (order (children y))) (count (keys (sibling y)) (order (children y))))))
(assert (= (count (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y))) (order' nil)) (+ (count (munion (msingleton (key y)) (keys (children y))) (order' nil)) (count (keys (sibling y)) (order' nil)))))
(assert (= (count (munion (msingleton (key x)) (keys (children x))) w1) (+ (count (msingleton (key x)) w1) (count (keys (children x)) w1))))
(assert (= (count (munion (msingleton (key x)) (keys (children x))) w2) (+ (count (msingleton (key x)) w2) (count (keys (children x)) w2))))
(assert (= (count (munion (msingleton (key x)) (keys (children x))) (+ (order (children x)) 1)) (+ (count (msingleton (key x)) (+ (order (children x)) 1)) (count (keys (children x)) (+ (order (children x)) 1)))))
(assert (= (count (munion (msingleton (key x)) (keys (children x))) (+ (order (children y)) 1)) (+ (count (msingleton (key x)) (+ (order (children y)) 1)) (count (keys (children x)) (+ (order (children y)) 1)))))
(assert (= (count (munion (msingleton (key x)) (keys (children x))) (+ (order x) 1)) (+ (count (msingleton (key x)) (+ (order x) 1)) (count (keys (children x)) (+ (order x) 1)))))
(assert (= (count (munion (msingleton (key x)) (keys (children x))) (+ (order y) 1)) (+ (count (msingleton (key x)) (+ (order y) 1)) (count (keys (children x)) (+ (order y) 1)))))
(assert (= (count (munion (msingleton (key x)) (keys (children x))) (key x)) (+ (count (msingleton (key x)) (key x)) (count (keys (children x)) (key x)))))
(assert (= (count (munion (msingleton (key x)) (keys (children x))) (key y)) (+ (count (msingleton (key x)) (key y)) (count (keys (children x)) (key y)))))
(assert (= (count (munion (msingleton (key x)) (keys (children x))) (order nil)) (+ (count (msingleton (key x)) (order nil)) (count (keys (children x)) (order nil)))))
(assert (= (count (munion (msingleton (key x)) (keys (children x))) (order x)) (+ (count (msingleton (key x)) (order x)) (count (keys (children x)) (order x)))))
(assert (= (count (munion (msingleton (key x)) (keys (children x))) (order y)) (+ (count (msingleton (key x)) (order y)) (count (keys (children x)) (order y)))))
(assert (= (count (munion (msingleton (key x)) (keys (children x))) (order (sibling x))) (+ (count (msingleton (key x)) (order (sibling x))) (count (keys (children x)) (order (sibling x))))))
(assert (= (count (munion (msingleton (key x)) (keys (children x))) (order (sibling y))) (+ (count (msingleton (key x)) (order (sibling y))) (count (keys (children x)) (order (sibling y))))))
(assert (= (count (munion (msingleton (key x)) (keys (children x))) (order (children x))) (+ (count (msingleton (key x)) (order (children x))) (count (keys (children x)) (order (children x))))))
(assert (= (count (munion (msingleton (key x)) (keys (children x))) (order (children y))) (+ (count (msingleton (key x)) (order (children y))) (count (keys (children x)) (order (children y))))))
(assert (= (count (munion (msingleton (key x)) (keys (children x))) (order' nil)) (+ (count (msingleton (key x)) (order' nil)) (count (keys (children x)) (order' nil)))))
(assert (= (count (munion (msingleton (key y)) (keys (children y))) w1) (+ (count (msingleton (key y)) w1) (count (keys (children y)) w1))))
(assert (= (count (munion (msingleton (key y)) (keys (children y))) w2) (+ (count (msingleton (key y)) w2) (count (keys (children y)) w2))))
(assert (= (count (munion (msingleton (key y)) (keys (children y))) (+ (order (children x)) 1)) (+ (count (msingleton (key y)) (+ (order (children x)) 1)) (count (keys (children y)) (+ (order (children x)) 1)))))
(assert (= (count (munion (msingleton (key y)) (keys (children y))) (+ (order (children y)) 1)) (+ (count (msingleton (key y)) (+ (order (children y)) 1)) (count (keys (children y)) (+ (order (children y)) 1)))))
(assert (= (count (munion (msingleton (key y)) (keys (children y))) (+ (order x) 1)) (+ (count (msingleton (key y)) (+ (order x) 1)) (count (keys (children y)) (+ (order x) 1)))))
(assert (= (count (munion (msingleton (key y)) (keys (children y))) (+ (order y) 1)) (+ (count (msingleton (key y)) (+ (order y) 1)) (count (keys (children y)) (+ (order y) 1)))))
(assert (= (count (munion (msingleton (key y)) (keys (children y))) (key x)) (+ (count (msingleton (key y)) (key x)) (count (keys (children y)) (key x)))))
(assert (= (count (munion (msingleton (key y)) (keys (children y))) (key y)) (+ (count (msingleton (key y)) (key y)) (count (keys (children y)) (key y)))))
(assert (= (count (munion (msingleton (key y)) (keys (children y))) (order nil)) (+ (count (msingleton (key y)) (order nil)) (count (keys (children y)) (order nil)))))
(assert (= (count (munion (msingleton (key y)) (keys (children y))) (order x)) (+ (count (msingleton (key y)) (order x)) (count (keys (children y)) (order x)))))
(assert (= (count (munion (msingleton (key y)) (keys (children y))) (order y)) (+ (count (msingleton (key y)) (order y)) (count (keys (children y)) (order y)))))
(assert (= (count (munion (msingleton (key y)) (keys (children y))) (order (sibling x))) (+ (count (msingleton (key y)) (order (sibling x))) (count (keys (children y)) (order (sibling x))))))
(assert (= (count (munion (msingleton (key y)) (keys (children y))) (order (sibling y))) (+ (count (msingleton (key y)) (order (sibling y))) (count (keys (children y)) (order (sibling y))))))
(assert (= (count (munion (msingleton (key y)) (keys (children y))) (order (children x))) (+ (count (msingleton (key y)) (order (children x))) (count (keys (children y)) (order (children x))))))
(assert (= (count (munion (msingleton (key y)) (keys (children y))) (order (children y))) (+ (count (msingleton (key y)) (order (children y))) (count (keys (children y)) (order (children y))))))
(assert (= (count (munion (msingleton (key y)) (keys (children y))) (order' nil)) (+ (count (msingleton (key y)) (order' nil)) (count (keys (children y)) (order' nil)))))
(assert (= (count (munion (keys x) (keys y)) w1) (+ (count (keys x) w1) (count (keys y) w1))))
(assert (= (count (munion (keys x) (keys y)) w2) (+ (count (keys x) w2) (count (keys y) w2))))
(assert (= (count (munion (keys x) (keys y)) (+ (order (children x)) 1)) (+ (count (keys x) (+ (order (children x)) 1)) (count (keys y) (+ (order (children x)) 1)))))
(assert (= (count (munion (keys x) (keys y)) (+ (order (children y)) 1)) (+ (count (keys x) (+ (order (children y)) 1)) (count (keys y) (+ (order (children y)) 1)))))
(assert (= (count (munion (keys x) (keys y)) (+ (order x) 1)) (+ (count (keys x) (+ (order x) 1)) (count (keys y) (+ (order x) 1)))))
(assert (= (count (munion (keys x) (keys y)) (+ (order y) 1)) (+ (count (keys x) (+ (order y) 1)) (count (keys y) (+ (order y) 1)))))
(assert (= (count (munion (keys x) (keys y)) (key x)) (+ (count (keys x) (key x)) (count (keys y) (key x)))))
(assert (= (count (munion (keys x) (keys y)) (key y)) (+ (count (keys x) (key y)) (count (keys y) (key y)))))
(assert (= (count (munion (keys x) (keys y)) (order nil)) (+ (count (keys x) (order nil)) (count (keys y) (order nil)))))
(assert (= (count (munion (keys x) (keys y)) (order x)) (+ (count (keys x) (order x)) (count (keys y) (order x)))))
(assert (= (count (munion (keys x) (keys y)) (order y)) (+ (count (keys x) (order y)) (count (keys y) (order y)))))
(assert (= (count (munion (keys x) (keys y)) (order (sibling x))) (+ (count (keys x) (order (sibling x))) (count (keys y) (order (sibling x))))))
(assert (= (count (munion (keys x) (keys y)) (order (sibling y))) (+ (count (keys x) (order (sibling y))) (count (keys y) (order (sibling y))))))
(assert (= (count (munion (keys x) (keys y)) (order (children x))) (+ (count (keys x) (order (children x))) (count (keys y) (order (children x))))))
(assert (= (count (munion (keys x) (keys y)) (order (children y))) (+ (count (keys x) (order (children y))) (count (keys y) (order (children y))))))
(assert (= (count (munion (keys x) (keys y)) (order' nil)) (+ (count (keys x) (order' nil)) (count (keys y) (order' nil)))))



(assert (= (count (msingleton (key x)) w1) (ite (= w1 (key x)) 1 0)))
(assert (= (count (msingleton (key x)) w2) (ite (= w2 (key x)) 1 0)))
(assert (= (count (msingleton (key x)) (+ (order (children x)) 1)) (ite (= (+ (order (children x)) 1) (key x)) 1 0)))
(assert (= (count (msingleton (key x)) (+ (order (children y)) 1)) (ite (= (+ (order (children y)) 1) (key x)) 1 0)))
(assert (= (count (msingleton (key x)) (+ (order x) 1)) (ite (= (+ (order x) 1) (key x)) 1 0)))
(assert (= (count (msingleton (key x)) (+ (order y) 1)) (ite (= (+ (order y) 1) (key x)) 1 0)))
(assert (= (count (msingleton (key x)) (key x)) (ite (= (key x) (key x)) 1 0)))
(assert (= (count (msingleton (key x)) (key y)) (ite (= (key y) (key x)) 1 0)))
(assert (= (count (msingleton (key x)) (order nil)) (ite (= (order nil) (key x)) 1 0)))
(assert (= (count (msingleton (key x)) (order x)) (ite (= (order x) (key x)) 1 0)))
(assert (= (count (msingleton (key x)) (order y)) (ite (= (order y) (key x)) 1 0)))
(assert (= (count (msingleton (key x)) (order (sibling x))) (ite (= (order (sibling x)) (key x)) 1 0)))
(assert (= (count (msingleton (key x)) (order (sibling y))) (ite (= (order (sibling y)) (key x)) 1 0)))
(assert (= (count (msingleton (key x)) (order (children x))) (ite (= (order (children x)) (key x)) 1 0)))
(assert (= (count (msingleton (key x)) (order (children y))) (ite (= (order (children y)) (key x)) 1 0)))
(assert (= (count (msingleton (key x)) (order' nil)) (ite (= (order' nil) (key x)) 1 0)))
(assert (= (count (msingleton (key y)) w1) (ite (= w1 (key y)) 1 0)))
(assert (= (count (msingleton (key y)) w2) (ite (= w2 (key y)) 1 0)))
(assert (= (count (msingleton (key y)) (+ (order (children x)) 1)) (ite (= (+ (order (children x)) 1) (key y)) 1 0)))
(assert (= (count (msingleton (key y)) (+ (order (children y)) 1)) (ite (= (+ (order (children y)) 1) (key y)) 1 0)))
(assert (= (count (msingleton (key y)) (+ (order x) 1)) (ite (= (+ (order x) 1) (key y)) 1 0)))
(assert (= (count (msingleton (key y)) (+ (order y) 1)) (ite (= (+ (order y) 1) (key y)) 1 0)))
(assert (= (count (msingleton (key y)) (key x)) (ite (= (key x) (key y)) 1 0)))
(assert (= (count (msingleton (key y)) (key y)) (ite (= (key y) (key y)) 1 0)))
(assert (= (count (msingleton (key y)) (order nil)) (ite (= (order nil) (key y)) 1 0)))
(assert (= (count (msingleton (key y)) (order x)) (ite (= (order x) (key y)) 1 0)))
(assert (= (count (msingleton (key y)) (order y)) (ite (= (order y) (key y)) 1 0)))
(assert (= (count (msingleton (key y)) (order (sibling x))) (ite (= (order (sibling x)) (key y)) 1 0)))
(assert (= (count (msingleton (key y)) (order (sibling y))) (ite (= (order (sibling y)) (key y)) 1 0)))
(assert (= (count (msingleton (key y)) (order (children x))) (ite (= (order (children x)) (key y)) 1 0)))
(assert (= (count (msingleton (key y)) (order (children y))) (ite (= (order (children y)) (key y)) 1 0)))
(assert (= (count (msingleton (key y)) (order' nil)) (ite (= (order' nil) (key y)) 1 0)))


(assert (=> (meq (keys nil) emptymset) (= (count (keys nil) w1) (count emptymset w1))))
(assert (=> (meq (keys nil) emptymset) (= (count (keys nil) w2) (count emptymset w2))))
(assert (=> (meq (keys nil) emptymset) (= (count (keys nil) (+ (order (children x)) 1)) (count emptymset (+ (order (children x)) 1)))))
(assert (=> (meq (keys nil) emptymset) (= (count (keys nil) (+ (order (children y)) 1)) (count emptymset (+ (order (children y)) 1)))))
(assert (=> (meq (keys nil) emptymset) (= (count (keys nil) (+ (order x) 1)) (count emptymset (+ (order x) 1)))))
(assert (=> (meq (keys nil) emptymset) (= (count (keys nil) (+ (order y) 1)) (count emptymset (+ (order y) 1)))))
(assert (=> (meq (keys nil) emptymset) (= (count (keys nil) (key x)) (count emptymset (key x)))))
(assert (=> (meq (keys nil) emptymset) (= (count (keys nil) (key y)) (count emptymset (key y)))))
(assert (=> (meq (keys nil) emptymset) (= (count (keys nil) (order nil)) (count emptymset (order nil)))))
(assert (=> (meq (keys nil) emptymset) (= (count (keys nil) (order x)) (count emptymset (order x)))))
(assert (=> (meq (keys nil) emptymset) (= (count (keys nil) (order y)) (count emptymset (order y)))))
(assert (=> (meq (keys nil) emptymset) (= (count (keys nil) (order (sibling x))) (count emptymset (order (sibling x))))))
(assert (=> (meq (keys nil) emptymset) (= (count (keys nil) (order (sibling y))) (count emptymset (order (sibling y))))))
(assert (=> (meq (keys nil) emptymset) (= (count (keys nil) (order (children x))) (count emptymset (order (children x))))))
(assert (=> (meq (keys nil) emptymset) (= (count (keys nil) (order (children y))) (count emptymset (order (children y))))))
(assert (=> (meq (keys nil) emptymset) (= (count (keys nil) (order' nil)) (count emptymset (order' nil)))))
(assert (=> (meq (keys' nil) emptymset) (= (count (keys' nil) w1) (count emptymset w1))))
(assert (=> (meq (keys' nil) emptymset) (= (count (keys' nil) w2) (count emptymset w2))))
(assert (=> (meq (keys' nil) emptymset) (= (count (keys' nil) (+ (order (children x)) 1)) (count emptymset (+ (order (children x)) 1)))))
(assert (=> (meq (keys' nil) emptymset) (= (count (keys' nil) (+ (order (children y)) 1)) (count emptymset (+ (order (children y)) 1)))))
(assert (=> (meq (keys' nil) emptymset) (= (count (keys' nil) (+ (order x) 1)) (count emptymset (+ (order x) 1)))))
(assert (=> (meq (keys' nil) emptymset) (= (count (keys' nil) (+ (order y) 1)) (count emptymset (+ (order y) 1)))))
(assert (=> (meq (keys' nil) emptymset) (= (count (keys' nil) (key x)) (count emptymset (key x)))))
(assert (=> (meq (keys' nil) emptymset) (= (count (keys' nil) (key y)) (count emptymset (key y)))))
(assert (=> (meq (keys' nil) emptymset) (= (count (keys' nil) (order nil)) (count emptymset (order nil)))))
(assert (=> (meq (keys' nil) emptymset) (= (count (keys' nil) (order x)) (count emptymset (order x)))))
(assert (=> (meq (keys' nil) emptymset) (= (count (keys' nil) (order y)) (count emptymset (order y)))))
(assert (=> (meq (keys' nil) emptymset) (= (count (keys' nil) (order (sibling x))) (count emptymset (order (sibling x))))))
(assert (=> (meq (keys' nil) emptymset) (= (count (keys' nil) (order (sibling y))) (count emptymset (order (sibling y))))))
(assert (=> (meq (keys' nil) emptymset) (= (count (keys' nil) (order (children x))) (count emptymset (order (children x))))))
(assert (=> (meq (keys' nil) emptymset) (= (count (keys' nil) (order (children y))) (count emptymset (order (children y))))))
(assert (=> (meq (keys' nil) emptymset) (= (count (keys' nil) (order' nil)) (count emptymset (order' nil)))))
(assert (=> (meq (keys x) emptymset) (= (count (keys x) w1) (count emptymset w1))))
(assert (=> (meq (keys x) emptymset) (= (count (keys x) w2) (count emptymset w2))))
(assert (=> (meq (keys x) emptymset) (= (count (keys x) (+ (order (children x)) 1)) (count emptymset (+ (order (children x)) 1)))))
(assert (=> (meq (keys x) emptymset) (= (count (keys x) (+ (order (children y)) 1)) (count emptymset (+ (order (children y)) 1)))))
(assert (=> (meq (keys x) emptymset) (= (count (keys x) (+ (order x) 1)) (count emptymset (+ (order x) 1)))))
(assert (=> (meq (keys x) emptymset) (= (count (keys x) (+ (order y) 1)) (count emptymset (+ (order y) 1)))))
(assert (=> (meq (keys x) emptymset) (= (count (keys x) (key x)) (count emptymset (key x)))))
(assert (=> (meq (keys x) emptymset) (= (count (keys x) (key y)) (count emptymset (key y)))))
(assert (=> (meq (keys x) emptymset) (= (count (keys x) (order nil)) (count emptymset (order nil)))))
(assert (=> (meq (keys x) emptymset) (= (count (keys x) (order x)) (count emptymset (order x)))))
(assert (=> (meq (keys x) emptymset) (= (count (keys x) (order y)) (count emptymset (order y)))))
(assert (=> (meq (keys x) emptymset) (= (count (keys x) (order (sibling x))) (count emptymset (order (sibling x))))))
(assert (=> (meq (keys x) emptymset) (= (count (keys x) (order (sibling y))) (count emptymset (order (sibling y))))))
(assert (=> (meq (keys x) emptymset) (= (count (keys x) (order (children x))) (count emptymset (order (children x))))))
(assert (=> (meq (keys x) emptymset) (= (count (keys x) (order (children y))) (count emptymset (order (children y))))))
(assert (=> (meq (keys x) emptymset) (= (count (keys x) (order' nil)) (count emptymset (order' nil)))))
(assert (=> (meq (keys y) emptymset) (= (count (keys y) w1) (count emptymset w1))))
(assert (=> (meq (keys y) emptymset) (= (count (keys y) w2) (count emptymset w2))))
(assert (=> (meq (keys y) emptymset) (= (count (keys y) (+ (order (children x)) 1)) (count emptymset (+ (order (children x)) 1)))))
(assert (=> (meq (keys y) emptymset) (= (count (keys y) (+ (order (children y)) 1)) (count emptymset (+ (order (children y)) 1)))))
(assert (=> (meq (keys y) emptymset) (= (count (keys y) (+ (order x) 1)) (count emptymset (+ (order x) 1)))))
(assert (=> (meq (keys y) emptymset) (= (count (keys y) (+ (order y) 1)) (count emptymset (+ (order y) 1)))))
(assert (=> (meq (keys y) emptymset) (= (count (keys y) (key x)) (count emptymset (key x)))))
(assert (=> (meq (keys y) emptymset) (= (count (keys y) (key y)) (count emptymset (key y)))))
(assert (=> (meq (keys y) emptymset) (= (count (keys y) (order nil)) (count emptymset (order nil)))))
(assert (=> (meq (keys y) emptymset) (= (count (keys y) (order x)) (count emptymset (order x)))))
(assert (=> (meq (keys y) emptymset) (= (count (keys y) (order y)) (count emptymset (order y)))))
(assert (=> (meq (keys y) emptymset) (= (count (keys y) (order (sibling x))) (count emptymset (order (sibling x))))))
(assert (=> (meq (keys y) emptymset) (= (count (keys y) (order (sibling y))) (count emptymset (order (sibling y))))))
(assert (=> (meq (keys y) emptymset) (= (count (keys y) (order (children x))) (count emptymset (order (children x))))))
(assert (=> (meq (keys y) emptymset) (= (count (keys y) (order (children y))) (count emptymset (order (children y))))))
(assert (=> (meq (keys y) emptymset) (= (count (keys y) (order' nil)) (count emptymset (order' nil)))))
(assert (=> (meq (keys x) (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x)))) (= (count (keys x) w1) (count (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x))) w1))))
(assert (=> (meq (keys x) (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x)))) (= (count (keys x) w2) (count (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x))) w2))))
(assert (=> (meq (keys x) (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x)))) (= (count (keys x) (+ (order (children x)) 1)) (count (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x))) (+ (order (children x)) 1)))))
(assert (=> (meq (keys x) (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x)))) (= (count (keys x) (+ (order (children y)) 1)) (count (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x))) (+ (order (children y)) 1)))))
(assert (=> (meq (keys x) (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x)))) (= (count (keys x) (+ (order x) 1)) (count (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x))) (+ (order x) 1)))))
(assert (=> (meq (keys x) (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x)))) (= (count (keys x) (+ (order y) 1)) (count (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x))) (+ (order y) 1)))))
(assert (=> (meq (keys x) (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x)))) (= (count (keys x) (key x)) (count (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x))) (key x)))))
(assert (=> (meq (keys x) (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x)))) (= (count (keys x) (key y)) (count (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x))) (key y)))))
(assert (=> (meq (keys x) (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x)))) (= (count (keys x) (order nil)) (count (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x))) (order nil)))))
(assert (=> (meq (keys x) (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x)))) (= (count (keys x) (order x)) (count (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x))) (order x)))))
(assert (=> (meq (keys x) (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x)))) (= (count (keys x) (order y)) (count (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x))) (order y)))))
(assert (=> (meq (keys x) (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x)))) (= (count (keys x) (order (sibling x))) (count (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x))) (order (sibling x))))))
(assert (=> (meq (keys x) (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x)))) (= (count (keys x) (order (sibling y))) (count (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x))) (order (sibling y))))))
(assert (=> (meq (keys x) (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x)))) (= (count (keys x) (order (children x))) (count (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x))) (order (children x))))))
(assert (=> (meq (keys x) (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x)))) (= (count (keys x) (order (children y))) (count (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x))) (order (children y))))))
(assert (=> (meq (keys x) (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x)))) (= (count (keys x) (order' nil)) (count (munion (munion (msingleton (key x)) (keys (children x))) (keys (sibling x))) (order' nil)))))
(assert (=> (meq (keys y) (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y)))) (= (count (keys y) w1) (count (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y))) w1))))
(assert (=> (meq (keys y) (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y)))) (= (count (keys y) w2) (count (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y))) w2))))
(assert (=> (meq (keys y) (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y)))) (= (count (keys y) (+ (order (children x)) 1)) (count (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y))) (+ (order (children x)) 1)))))
(assert (=> (meq (keys y) (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y)))) (= (count (keys y) (+ (order (children y)) 1)) (count (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y))) (+ (order (children y)) 1)))))
(assert (=> (meq (keys y) (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y)))) (= (count (keys y) (+ (order x) 1)) (count (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y))) (+ (order x) 1)))))
(assert (=> (meq (keys y) (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y)))) (= (count (keys y) (+ (order y) 1)) (count (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y))) (+ (order y) 1)))))
(assert (=> (meq (keys y) (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y)))) (= (count (keys y) (key x)) (count (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y))) (key x)))))
(assert (=> (meq (keys y) (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y)))) (= (count (keys y) (key y)) (count (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y))) (key y)))))
(assert (=> (meq (keys y) (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y)))) (= (count (keys y) (order nil)) (count (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y))) (order nil)))))
(assert (=> (meq (keys y) (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y)))) (= (count (keys y) (order x)) (count (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y))) (order x)))))
(assert (=> (meq (keys y) (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y)))) (= (count (keys y) (order y)) (count (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y))) (order y)))))
(assert (=> (meq (keys y) (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y)))) (= (count (keys y) (order (sibling x))) (count (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y))) (order (sibling x))))))
(assert (=> (meq (keys y) (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y)))) (= (count (keys y) (order (sibling y))) (count (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y))) (order (sibling y))))))
(assert (=> (meq (keys y) (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y)))) (= (count (keys y) (order (children x))) (count (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y))) (order (children x))))))
(assert (=> (meq (keys y) (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y)))) (= (count (keys y) (order (children y))) (count (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y))) (order (children y))))))
(assert (=> (meq (keys y) (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y)))) (= (count (keys y) (order' nil)) (count (munion (munion (msingleton (key y)) (keys (children y))) (keys (sibling y))) (order' nil)))))
(assert (=> (meq (keys y) (munion (keys x) (keys y))) (= (count (keys y) w1) (count (munion (keys x) (keys y)) w1))))
(assert (=> (meq (keys y) (munion (keys x) (keys y))) (= (count (keys y) w2) (count (munion (keys x) (keys y)) w2))))
(assert (=> (meq (keys y) (munion (keys x) (keys y))) (= (count (keys y) (+ (order (children x)) 1)) (count (munion (keys x) (keys y)) (+ (order (children x)) 1)))))
(assert (=> (meq (keys y) (munion (keys x) (keys y))) (= (count (keys y) (+ (order (children y)) 1)) (count (munion (keys x) (keys y)) (+ (order (children y)) 1)))))
(assert (=> (meq (keys y) (munion (keys x) (keys y))) (= (count (keys y) (+ (order x) 1)) (count (munion (keys x) (keys y)) (+ (order x) 1)))))
(assert (=> (meq (keys y) (munion (keys x) (keys y))) (= (count (keys y) (+ (order y) 1)) (count (munion (keys x) (keys y)) (+ (order y) 1)))))
(assert (=> (meq (keys y) (munion (keys x) (keys y))) (= (count (keys y) (key x)) (count (munion (keys x) (keys y)) (key x)))))
(assert (=> (meq (keys y) (munion (keys x) (keys y))) (= (count (keys y) (key y)) (count (munion (keys x) (keys y)) (key y)))))
(assert (=> (meq (keys y) (munion (keys x) (keys y))) (= (count (keys y) (order nil)) (count (munion (keys x) (keys y)) (order nil)))))
(assert (=> (meq (keys y) (munion (keys x) (keys y))) (= (count (keys y) (order x)) (count (munion (keys x) (keys y)) (order x)))))
(assert (=> (meq (keys y) (munion (keys x) (keys y))) (= (count (keys y) (order y)) (count (munion (keys x) (keys y)) (order y)))))
(assert (=> (meq (keys y) (munion (keys x) (keys y))) (= (count (keys y) (order (sibling x))) (count (munion (keys x) (keys y)) (order (sibling x))))))
(assert (=> (meq (keys y) (munion (keys x) (keys y))) (= (count (keys y) (order (sibling y))) (count (munion (keys x) (keys y)) (order (sibling y))))))
(assert (=> (meq (keys y) (munion (keys x) (keys y))) (= (count (keys y) (order (children x))) (count (munion (keys x) (keys y)) (order (children x))))))
(assert (=> (meq (keys y) (munion (keys x) (keys y))) (= (count (keys y) (order (children y))) (count (munion (keys x) (keys y)) (order (children y))))))
(assert (=> (meq (keys y) (munion (keys x) (keys y))) (= (count (keys y) (order' nil)) (count (munion (keys x) (keys y)) (order' nil)))))



(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) w1) 0) (> (count (keys (children x)) w1) 0)) (<= w1 w1))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) w1) 0) (> (count (keys (children x)) w2) 0)) (<= w1 w2))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) w1) 0) (> (count (keys (children x)) (+ (order (children x)) 1)) 0)) (<= w1 (+ (order (children x)) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) w1) 0) (> (count (keys (children x)) (+ (order (children y)) 1)) 0)) (<= w1 (+ (order (children y)) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) w1) 0) (> (count (keys (children x)) (+ (order x) 1)) 0)) (<= w1 (+ (order x) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) w1) 0) (> (count (keys (children x)) (+ (order y) 1)) 0)) (<= w1 (+ (order y) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) w1) 0) (> (count (keys (children x)) (key x)) 0)) (<= w1 (key x)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) w1) 0) (> (count (keys (children x)) (key y)) 0)) (<= w1 (key y)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) w1) 0) (> (count (keys (children x)) (order nil)) 0)) (<= w1 (order nil)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) w1) 0) (> (count (keys (children x)) (order x)) 0)) (<= w1 (order x)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) w1) 0) (> (count (keys (children x)) (order y)) 0)) (<= w1 (order y)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) w1) 0) (> (count (keys (children x)) (order (sibling x))) 0)) (<= w1 (order (sibling x))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) w1) 0) (> (count (keys (children x)) (order (sibling y))) 0)) (<= w1 (order (sibling y))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) w1) 0) (> (count (keys (children x)) (order (children x))) 0)) (<= w1 (order (children x))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) w1) 0) (> (count (keys (children x)) (order (children y))) 0)) (<= w1 (order (children y))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) w1) 0) (> (count (keys (children x)) (order' nil)) 0)) (<= w1 (order' nil)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) w2) 0) (> (count (keys (children x)) w1) 0)) (<= w2 w1))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) w2) 0) (> (count (keys (children x)) w2) 0)) (<= w2 w2))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) w2) 0) (> (count (keys (children x)) (+ (order (children x)) 1)) 0)) (<= w2 (+ (order (children x)) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) w2) 0) (> (count (keys (children x)) (+ (order (children y)) 1)) 0)) (<= w2 (+ (order (children y)) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) w2) 0) (> (count (keys (children x)) (+ (order x) 1)) 0)) (<= w2 (+ (order x) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) w2) 0) (> (count (keys (children x)) (+ (order y) 1)) 0)) (<= w2 (+ (order y) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) w2) 0) (> (count (keys (children x)) (key x)) 0)) (<= w2 (key x)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) w2) 0) (> (count (keys (children x)) (key y)) 0)) (<= w2 (key y)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) w2) 0) (> (count (keys (children x)) (order nil)) 0)) (<= w2 (order nil)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) w2) 0) (> (count (keys (children x)) (order x)) 0)) (<= w2 (order x)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) w2) 0) (> (count (keys (children x)) (order y)) 0)) (<= w2 (order y)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) w2) 0) (> (count (keys (children x)) (order (sibling x))) 0)) (<= w2 (order (sibling x))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) w2) 0) (> (count (keys (children x)) (order (sibling y))) 0)) (<= w2 (order (sibling y))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) w2) 0) (> (count (keys (children x)) (order (children x))) 0)) (<= w2 (order (children x))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) w2) 0) (> (count (keys (children x)) (order (children y))) 0)) (<= w2 (order (children y))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) w2) 0) (> (count (keys (children x)) (order' nil)) 0)) (<= w2 (order' nil)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order (children x)) 1)) 0) (> (count (keys (children x)) w1) 0)) (<= (+ (order (children x)) 1) w1))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order (children x)) 1)) 0) (> (count (keys (children x)) w2) 0)) (<= (+ (order (children x)) 1) w2))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order (children x)) 1)) 0) (> (count (keys (children x)) (+ (order (children x)) 1)) 0)) (<= (+ (order (children x)) 1) (+ (order (children x)) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order (children x)) 1)) 0) (> (count (keys (children x)) (+ (order (children y)) 1)) 0)) (<= (+ (order (children x)) 1) (+ (order (children y)) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order (children x)) 1)) 0) (> (count (keys (children x)) (+ (order x) 1)) 0)) (<= (+ (order (children x)) 1) (+ (order x) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order (children x)) 1)) 0) (> (count (keys (children x)) (+ (order y) 1)) 0)) (<= (+ (order (children x)) 1) (+ (order y) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order (children x)) 1)) 0) (> (count (keys (children x)) (key x)) 0)) (<= (+ (order (children x)) 1) (key x)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order (children x)) 1)) 0) (> (count (keys (children x)) (key y)) 0)) (<= (+ (order (children x)) 1) (key y)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order (children x)) 1)) 0) (> (count (keys (children x)) (order nil)) 0)) (<= (+ (order (children x)) 1) (order nil)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order (children x)) 1)) 0) (> (count (keys (children x)) (order x)) 0)) (<= (+ (order (children x)) 1) (order x)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order (children x)) 1)) 0) (> (count (keys (children x)) (order y)) 0)) (<= (+ (order (children x)) 1) (order y)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order (children x)) 1)) 0) (> (count (keys (children x)) (order (sibling x))) 0)) (<= (+ (order (children x)) 1) (order (sibling x))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order (children x)) 1)) 0) (> (count (keys (children x)) (order (sibling y))) 0)) (<= (+ (order (children x)) 1) (order (sibling y))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order (children x)) 1)) 0) (> (count (keys (children x)) (order (children x))) 0)) (<= (+ (order (children x)) 1) (order (children x))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order (children x)) 1)) 0) (> (count (keys (children x)) (order (children y))) 0)) (<= (+ (order (children x)) 1) (order (children y))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order (children x)) 1)) 0) (> (count (keys (children x)) (order' nil)) 0)) (<= (+ (order (children x)) 1) (order' nil)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order (children y)) 1)) 0) (> (count (keys (children x)) w1) 0)) (<= (+ (order (children y)) 1) w1))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order (children y)) 1)) 0) (> (count (keys (children x)) w2) 0)) (<= (+ (order (children y)) 1) w2))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order (children y)) 1)) 0) (> (count (keys (children x)) (+ (order (children x)) 1)) 0)) (<= (+ (order (children y)) 1) (+ (order (children x)) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order (children y)) 1)) 0) (> (count (keys (children x)) (+ (order (children y)) 1)) 0)) (<= (+ (order (children y)) 1) (+ (order (children y)) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order (children y)) 1)) 0) (> (count (keys (children x)) (+ (order x) 1)) 0)) (<= (+ (order (children y)) 1) (+ (order x) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order (children y)) 1)) 0) (> (count (keys (children x)) (+ (order y) 1)) 0)) (<= (+ (order (children y)) 1) (+ (order y) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order (children y)) 1)) 0) (> (count (keys (children x)) (key x)) 0)) (<= (+ (order (children y)) 1) (key x)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order (children y)) 1)) 0) (> (count (keys (children x)) (key y)) 0)) (<= (+ (order (children y)) 1) (key y)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order (children y)) 1)) 0) (> (count (keys (children x)) (order nil)) 0)) (<= (+ (order (children y)) 1) (order nil)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order (children y)) 1)) 0) (> (count (keys (children x)) (order x)) 0)) (<= (+ (order (children y)) 1) (order x)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order (children y)) 1)) 0) (> (count (keys (children x)) (order y)) 0)) (<= (+ (order (children y)) 1) (order y)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order (children y)) 1)) 0) (> (count (keys (children x)) (order (sibling x))) 0)) (<= (+ (order (children y)) 1) (order (sibling x))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order (children y)) 1)) 0) (> (count (keys (children x)) (order (sibling y))) 0)) (<= (+ (order (children y)) 1) (order (sibling y))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order (children y)) 1)) 0) (> (count (keys (children x)) (order (children x))) 0)) (<= (+ (order (children y)) 1) (order (children x))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order (children y)) 1)) 0) (> (count (keys (children x)) (order (children y))) 0)) (<= (+ (order (children y)) 1) (order (children y))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order (children y)) 1)) 0) (> (count (keys (children x)) (order' nil)) 0)) (<= (+ (order (children y)) 1) (order' nil)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order x) 1)) 0) (> (count (keys (children x)) w1) 0)) (<= (+ (order x) 1) w1))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order x) 1)) 0) (> (count (keys (children x)) w2) 0)) (<= (+ (order x) 1) w2))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order x) 1)) 0) (> (count (keys (children x)) (+ (order (children x)) 1)) 0)) (<= (+ (order x) 1) (+ (order (children x)) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order x) 1)) 0) (> (count (keys (children x)) (+ (order (children y)) 1)) 0)) (<= (+ (order x) 1) (+ (order (children y)) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order x) 1)) 0) (> (count (keys (children x)) (+ (order x) 1)) 0)) (<= (+ (order x) 1) (+ (order x) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order x) 1)) 0) (> (count (keys (children x)) (+ (order y) 1)) 0)) (<= (+ (order x) 1) (+ (order y) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order x) 1)) 0) (> (count (keys (children x)) (key x)) 0)) (<= (+ (order x) 1) (key x)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order x) 1)) 0) (> (count (keys (children x)) (key y)) 0)) (<= (+ (order x) 1) (key y)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order x) 1)) 0) (> (count (keys (children x)) (order nil)) 0)) (<= (+ (order x) 1) (order nil)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order x) 1)) 0) (> (count (keys (children x)) (order x)) 0)) (<= (+ (order x) 1) (order x)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order x) 1)) 0) (> (count (keys (children x)) (order y)) 0)) (<= (+ (order x) 1) (order y)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order x) 1)) 0) (> (count (keys (children x)) (order (sibling x))) 0)) (<= (+ (order x) 1) (order (sibling x))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order x) 1)) 0) (> (count (keys (children x)) (order (sibling y))) 0)) (<= (+ (order x) 1) (order (sibling y))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order x) 1)) 0) (> (count (keys (children x)) (order (children x))) 0)) (<= (+ (order x) 1) (order (children x))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order x) 1)) 0) (> (count (keys (children x)) (order (children y))) 0)) (<= (+ (order x) 1) (order (children y))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order x) 1)) 0) (> (count (keys (children x)) (order' nil)) 0)) (<= (+ (order x) 1) (order' nil)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order y) 1)) 0) (> (count (keys (children x)) w1) 0)) (<= (+ (order y) 1) w1))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order y) 1)) 0) (> (count (keys (children x)) w2) 0)) (<= (+ (order y) 1) w2))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order y) 1)) 0) (> (count (keys (children x)) (+ (order (children x)) 1)) 0)) (<= (+ (order y) 1) (+ (order (children x)) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order y) 1)) 0) (> (count (keys (children x)) (+ (order (children y)) 1)) 0)) (<= (+ (order y) 1) (+ (order (children y)) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order y) 1)) 0) (> (count (keys (children x)) (+ (order x) 1)) 0)) (<= (+ (order y) 1) (+ (order x) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order y) 1)) 0) (> (count (keys (children x)) (+ (order y) 1)) 0)) (<= (+ (order y) 1) (+ (order y) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order y) 1)) 0) (> (count (keys (children x)) (key x)) 0)) (<= (+ (order y) 1) (key x)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order y) 1)) 0) (> (count (keys (children x)) (key y)) 0)) (<= (+ (order y) 1) (key y)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order y) 1)) 0) (> (count (keys (children x)) (order nil)) 0)) (<= (+ (order y) 1) (order nil)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order y) 1)) 0) (> (count (keys (children x)) (order x)) 0)) (<= (+ (order y) 1) (order x)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order y) 1)) 0) (> (count (keys (children x)) (order y)) 0)) (<= (+ (order y) 1) (order y)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order y) 1)) 0) (> (count (keys (children x)) (order (sibling x))) 0)) (<= (+ (order y) 1) (order (sibling x))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order y) 1)) 0) (> (count (keys (children x)) (order (sibling y))) 0)) (<= (+ (order y) 1) (order (sibling y))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order y) 1)) 0) (> (count (keys (children x)) (order (children x))) 0)) (<= (+ (order y) 1) (order (children x))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order y) 1)) 0) (> (count (keys (children x)) (order (children y))) 0)) (<= (+ (order y) 1) (order (children y))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (+ (order y) 1)) 0) (> (count (keys (children x)) (order' nil)) 0)) (<= (+ (order y) 1) (order' nil)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (key x)) 0) (> (count (keys (children x)) w1) 0)) (<= (key x) w1))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (key x)) 0) (> (count (keys (children x)) w2) 0)) (<= (key x) w2))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (key x)) 0) (> (count (keys (children x)) (+ (order (children x)) 1)) 0)) (<= (key x) (+ (order (children x)) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (key x)) 0) (> (count (keys (children x)) (+ (order (children y)) 1)) 0)) (<= (key x) (+ (order (children y)) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (key x)) 0) (> (count (keys (children x)) (+ (order x) 1)) 0)) (<= (key x) (+ (order x) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (key x)) 0) (> (count (keys (children x)) (+ (order y) 1)) 0)) (<= (key x) (+ (order y) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (key x)) 0) (> (count (keys (children x)) (key x)) 0)) (<= (key x) (key x)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (key x)) 0) (> (count (keys (children x)) (key y)) 0)) (<= (key x) (key y)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (key x)) 0) (> (count (keys (children x)) (order nil)) 0)) (<= (key x) (order nil)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (key x)) 0) (> (count (keys (children x)) (order x)) 0)) (<= (key x) (order x)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (key x)) 0) (> (count (keys (children x)) (order y)) 0)) (<= (key x) (order y)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (key x)) 0) (> (count (keys (children x)) (order (sibling x))) 0)) (<= (key x) (order (sibling x))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (key x)) 0) (> (count (keys (children x)) (order (sibling y))) 0)) (<= (key x) (order (sibling y))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (key x)) 0) (> (count (keys (children x)) (order (children x))) 0)) (<= (key x) (order (children x))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (key x)) 0) (> (count (keys (children x)) (order (children y))) 0)) (<= (key x) (order (children y))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (key x)) 0) (> (count (keys (children x)) (order' nil)) 0)) (<= (key x) (order' nil)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (key y)) 0) (> (count (keys (children x)) w1) 0)) (<= (key y) w1))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (key y)) 0) (> (count (keys (children x)) w2) 0)) (<= (key y) w2))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (key y)) 0) (> (count (keys (children x)) (+ (order (children x)) 1)) 0)) (<= (key y) (+ (order (children x)) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (key y)) 0) (> (count (keys (children x)) (+ (order (children y)) 1)) 0)) (<= (key y) (+ (order (children y)) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (key y)) 0) (> (count (keys (children x)) (+ (order x) 1)) 0)) (<= (key y) (+ (order x) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (key y)) 0) (> (count (keys (children x)) (+ (order y) 1)) 0)) (<= (key y) (+ (order y) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (key y)) 0) (> (count (keys (children x)) (key x)) 0)) (<= (key y) (key x)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (key y)) 0) (> (count (keys (children x)) (key y)) 0)) (<= (key y) (key y)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (key y)) 0) (> (count (keys (children x)) (order nil)) 0)) (<= (key y) (order nil)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (key y)) 0) (> (count (keys (children x)) (order x)) 0)) (<= (key y) (order x)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (key y)) 0) (> (count (keys (children x)) (order y)) 0)) (<= (key y) (order y)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (key y)) 0) (> (count (keys (children x)) (order (sibling x))) 0)) (<= (key y) (order (sibling x))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (key y)) 0) (> (count (keys (children x)) (order (sibling y))) 0)) (<= (key y) (order (sibling y))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (key y)) 0) (> (count (keys (children x)) (order (children x))) 0)) (<= (key y) (order (children x))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (key y)) 0) (> (count (keys (children x)) (order (children y))) 0)) (<= (key y) (order (children y))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (key y)) 0) (> (count (keys (children x)) (order' nil)) 0)) (<= (key y) (order' nil)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order nil)) 0) (> (count (keys (children x)) w1) 0)) (<= (order nil) w1))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order nil)) 0) (> (count (keys (children x)) w2) 0)) (<= (order nil) w2))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order nil)) 0) (> (count (keys (children x)) (+ (order (children x)) 1)) 0)) (<= (order nil) (+ (order (children x)) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order nil)) 0) (> (count (keys (children x)) (+ (order (children y)) 1)) 0)) (<= (order nil) (+ (order (children y)) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order nil)) 0) (> (count (keys (children x)) (+ (order x) 1)) 0)) (<= (order nil) (+ (order x) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order nil)) 0) (> (count (keys (children x)) (+ (order y) 1)) 0)) (<= (order nil) (+ (order y) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order nil)) 0) (> (count (keys (children x)) (key x)) 0)) (<= (order nil) (key x)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order nil)) 0) (> (count (keys (children x)) (key y)) 0)) (<= (order nil) (key y)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order nil)) 0) (> (count (keys (children x)) (order nil)) 0)) (<= (order nil) (order nil)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order nil)) 0) (> (count (keys (children x)) (order x)) 0)) (<= (order nil) (order x)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order nil)) 0) (> (count (keys (children x)) (order y)) 0)) (<= (order nil) (order y)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order nil)) 0) (> (count (keys (children x)) (order (sibling x))) 0)) (<= (order nil) (order (sibling x))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order nil)) 0) (> (count (keys (children x)) (order (sibling y))) 0)) (<= (order nil) (order (sibling y))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order nil)) 0) (> (count (keys (children x)) (order (children x))) 0)) (<= (order nil) (order (children x))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order nil)) 0) (> (count (keys (children x)) (order (children y))) 0)) (<= (order nil) (order (children y))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order nil)) 0) (> (count (keys (children x)) (order' nil)) 0)) (<= (order nil) (order' nil)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order x)) 0) (> (count (keys (children x)) w1) 0)) (<= (order x) w1))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order x)) 0) (> (count (keys (children x)) w2) 0)) (<= (order x) w2))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order x)) 0) (> (count (keys (children x)) (+ (order (children x)) 1)) 0)) (<= (order x) (+ (order (children x)) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order x)) 0) (> (count (keys (children x)) (+ (order (children y)) 1)) 0)) (<= (order x) (+ (order (children y)) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order x)) 0) (> (count (keys (children x)) (+ (order x) 1)) 0)) (<= (order x) (+ (order x) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order x)) 0) (> (count (keys (children x)) (+ (order y) 1)) 0)) (<= (order x) (+ (order y) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order x)) 0) (> (count (keys (children x)) (key x)) 0)) (<= (order x) (key x)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order x)) 0) (> (count (keys (children x)) (key y)) 0)) (<= (order x) (key y)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order x)) 0) (> (count (keys (children x)) (order nil)) 0)) (<= (order x) (order nil)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order x)) 0) (> (count (keys (children x)) (order x)) 0)) (<= (order x) (order x)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order x)) 0) (> (count (keys (children x)) (order y)) 0)) (<= (order x) (order y)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order x)) 0) (> (count (keys (children x)) (order (sibling x))) 0)) (<= (order x) (order (sibling x))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order x)) 0) (> (count (keys (children x)) (order (sibling y))) 0)) (<= (order x) (order (sibling y))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order x)) 0) (> (count (keys (children x)) (order (children x))) 0)) (<= (order x) (order (children x))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order x)) 0) (> (count (keys (children x)) (order (children y))) 0)) (<= (order x) (order (children y))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order x)) 0) (> (count (keys (children x)) (order' nil)) 0)) (<= (order x) (order' nil)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order y)) 0) (> (count (keys (children x)) w1) 0)) (<= (order y) w1))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order y)) 0) (> (count (keys (children x)) w2) 0)) (<= (order y) w2))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order y)) 0) (> (count (keys (children x)) (+ (order (children x)) 1)) 0)) (<= (order y) (+ (order (children x)) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order y)) 0) (> (count (keys (children x)) (+ (order (children y)) 1)) 0)) (<= (order y) (+ (order (children y)) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order y)) 0) (> (count (keys (children x)) (+ (order x) 1)) 0)) (<= (order y) (+ (order x) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order y)) 0) (> (count (keys (children x)) (+ (order y) 1)) 0)) (<= (order y) (+ (order y) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order y)) 0) (> (count (keys (children x)) (key x)) 0)) (<= (order y) (key x)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order y)) 0) (> (count (keys (children x)) (key y)) 0)) (<= (order y) (key y)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order y)) 0) (> (count (keys (children x)) (order nil)) 0)) (<= (order y) (order nil)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order y)) 0) (> (count (keys (children x)) (order x)) 0)) (<= (order y) (order x)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order y)) 0) (> (count (keys (children x)) (order y)) 0)) (<= (order y) (order y)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order y)) 0) (> (count (keys (children x)) (order (sibling x))) 0)) (<= (order y) (order (sibling x))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order y)) 0) (> (count (keys (children x)) (order (sibling y))) 0)) (<= (order y) (order (sibling y))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order y)) 0) (> (count (keys (children x)) (order (children x))) 0)) (<= (order y) (order (children x))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order y)) 0) (> (count (keys (children x)) (order (children y))) 0)) (<= (order y) (order (children y))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order y)) 0) (> (count (keys (children x)) (order' nil)) 0)) (<= (order y) (order' nil)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (sibling x))) 0) (> (count (keys (children x)) w1) 0)) (<= (order (sibling x)) w1))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (sibling x))) 0) (> (count (keys (children x)) w2) 0)) (<= (order (sibling x)) w2))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (sibling x))) 0) (> (count (keys (children x)) (+ (order (children x)) 1)) 0)) (<= (order (sibling x)) (+ (order (children x)) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (sibling x))) 0) (> (count (keys (children x)) (+ (order (children y)) 1)) 0)) (<= (order (sibling x)) (+ (order (children y)) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (sibling x))) 0) (> (count (keys (children x)) (+ (order x) 1)) 0)) (<= (order (sibling x)) (+ (order x) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (sibling x))) 0) (> (count (keys (children x)) (+ (order y) 1)) 0)) (<= (order (sibling x)) (+ (order y) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (sibling x))) 0) (> (count (keys (children x)) (key x)) 0)) (<= (order (sibling x)) (key x)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (sibling x))) 0) (> (count (keys (children x)) (key y)) 0)) (<= (order (sibling x)) (key y)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (sibling x))) 0) (> (count (keys (children x)) (order nil)) 0)) (<= (order (sibling x)) (order nil)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (sibling x))) 0) (> (count (keys (children x)) (order x)) 0)) (<= (order (sibling x)) (order x)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (sibling x))) 0) (> (count (keys (children x)) (order y)) 0)) (<= (order (sibling x)) (order y)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (sibling x))) 0) (> (count (keys (children x)) (order (sibling x))) 0)) (<= (order (sibling x)) (order (sibling x))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (sibling x))) 0) (> (count (keys (children x)) (order (sibling y))) 0)) (<= (order (sibling x)) (order (sibling y))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (sibling x))) 0) (> (count (keys (children x)) (order (children x))) 0)) (<= (order (sibling x)) (order (children x))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (sibling x))) 0) (> (count (keys (children x)) (order (children y))) 0)) (<= (order (sibling x)) (order (children y))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (sibling x))) 0) (> (count (keys (children x)) (order' nil)) 0)) (<= (order (sibling x)) (order' nil)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (sibling y))) 0) (> (count (keys (children x)) w1) 0)) (<= (order (sibling y)) w1))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (sibling y))) 0) (> (count (keys (children x)) w2) 0)) (<= (order (sibling y)) w2))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (sibling y))) 0) (> (count (keys (children x)) (+ (order (children x)) 1)) 0)) (<= (order (sibling y)) (+ (order (children x)) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (sibling y))) 0) (> (count (keys (children x)) (+ (order (children y)) 1)) 0)) (<= (order (sibling y)) (+ (order (children y)) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (sibling y))) 0) (> (count (keys (children x)) (+ (order x) 1)) 0)) (<= (order (sibling y)) (+ (order x) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (sibling y))) 0) (> (count (keys (children x)) (+ (order y) 1)) 0)) (<= (order (sibling y)) (+ (order y) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (sibling y))) 0) (> (count (keys (children x)) (key x)) 0)) (<= (order (sibling y)) (key x)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (sibling y))) 0) (> (count (keys (children x)) (key y)) 0)) (<= (order (sibling y)) (key y)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (sibling y))) 0) (> (count (keys (children x)) (order nil)) 0)) (<= (order (sibling y)) (order nil)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (sibling y))) 0) (> (count (keys (children x)) (order x)) 0)) (<= (order (sibling y)) (order x)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (sibling y))) 0) (> (count (keys (children x)) (order y)) 0)) (<= (order (sibling y)) (order y)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (sibling y))) 0) (> (count (keys (children x)) (order (sibling x))) 0)) (<= (order (sibling y)) (order (sibling x))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (sibling y))) 0) (> (count (keys (children x)) (order (sibling y))) 0)) (<= (order (sibling y)) (order (sibling y))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (sibling y))) 0) (> (count (keys (children x)) (order (children x))) 0)) (<= (order (sibling y)) (order (children x))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (sibling y))) 0) (> (count (keys (children x)) (order (children y))) 0)) (<= (order (sibling y)) (order (children y))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (sibling y))) 0) (> (count (keys (children x)) (order' nil)) 0)) (<= (order (sibling y)) (order' nil)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (children x))) 0) (> (count (keys (children x)) w1) 0)) (<= (order (children x)) w1))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (children x))) 0) (> (count (keys (children x)) w2) 0)) (<= (order (children x)) w2))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (children x))) 0) (> (count (keys (children x)) (+ (order (children x)) 1)) 0)) (<= (order (children x)) (+ (order (children x)) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (children x))) 0) (> (count (keys (children x)) (+ (order (children y)) 1)) 0)) (<= (order (children x)) (+ (order (children y)) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (children x))) 0) (> (count (keys (children x)) (+ (order x) 1)) 0)) (<= (order (children x)) (+ (order x) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (children x))) 0) (> (count (keys (children x)) (+ (order y) 1)) 0)) (<= (order (children x)) (+ (order y) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (children x))) 0) (> (count (keys (children x)) (key x)) 0)) (<= (order (children x)) (key x)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (children x))) 0) (> (count (keys (children x)) (key y)) 0)) (<= (order (children x)) (key y)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (children x))) 0) (> (count (keys (children x)) (order nil)) 0)) (<= (order (children x)) (order nil)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (children x))) 0) (> (count (keys (children x)) (order x)) 0)) (<= (order (children x)) (order x)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (children x))) 0) (> (count (keys (children x)) (order y)) 0)) (<= (order (children x)) (order y)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (children x))) 0) (> (count (keys (children x)) (order (sibling x))) 0)) (<= (order (children x)) (order (sibling x))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (children x))) 0) (> (count (keys (children x)) (order (sibling y))) 0)) (<= (order (children x)) (order (sibling y))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (children x))) 0) (> (count (keys (children x)) (order (children x))) 0)) (<= (order (children x)) (order (children x))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (children x))) 0) (> (count (keys (children x)) (order (children y))) 0)) (<= (order (children x)) (order (children y))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (children x))) 0) (> (count (keys (children x)) (order' nil)) 0)) (<= (order (children x)) (order' nil)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (children y))) 0) (> (count (keys (children x)) w1) 0)) (<= (order (children y)) w1))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (children y))) 0) (> (count (keys (children x)) w2) 0)) (<= (order (children y)) w2))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (children y))) 0) (> (count (keys (children x)) (+ (order (children x)) 1)) 0)) (<= (order (children y)) (+ (order (children x)) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (children y))) 0) (> (count (keys (children x)) (+ (order (children y)) 1)) 0)) (<= (order (children y)) (+ (order (children y)) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (children y))) 0) (> (count (keys (children x)) (+ (order x) 1)) 0)) (<= (order (children y)) (+ (order x) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (children y))) 0) (> (count (keys (children x)) (+ (order y) 1)) 0)) (<= (order (children y)) (+ (order y) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (children y))) 0) (> (count (keys (children x)) (key x)) 0)) (<= (order (children y)) (key x)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (children y))) 0) (> (count (keys (children x)) (key y)) 0)) (<= (order (children y)) (key y)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (children y))) 0) (> (count (keys (children x)) (order nil)) 0)) (<= (order (children y)) (order nil)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (children y))) 0) (> (count (keys (children x)) (order x)) 0)) (<= (order (children y)) (order x)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (children y))) 0) (> (count (keys (children x)) (order y)) 0)) (<= (order (children y)) (order y)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (children y))) 0) (> (count (keys (children x)) (order (sibling x))) 0)) (<= (order (children y)) (order (sibling x))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (children y))) 0) (> (count (keys (children x)) (order (sibling y))) 0)) (<= (order (children y)) (order (sibling y))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (children y))) 0) (> (count (keys (children x)) (order (children x))) 0)) (<= (order (children y)) (order (children x))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (children y))) 0) (> (count (keys (children x)) (order (children y))) 0)) (<= (order (children y)) (order (children y))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order (children y))) 0) (> (count (keys (children x)) (order' nil)) 0)) (<= (order (children y)) (order' nil)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order' nil)) 0) (> (count (keys (children x)) w1) 0)) (<= (order' nil) w1))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order' nil)) 0) (> (count (keys (children x)) w2) 0)) (<= (order' nil) w2))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order' nil)) 0) (> (count (keys (children x)) (+ (order (children x)) 1)) 0)) (<= (order' nil) (+ (order (children x)) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order' nil)) 0) (> (count (keys (children x)) (+ (order (children y)) 1)) 0)) (<= (order' nil) (+ (order (children y)) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order' nil)) 0) (> (count (keys (children x)) (+ (order x) 1)) 0)) (<= (order' nil) (+ (order x) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order' nil)) 0) (> (count (keys (children x)) (+ (order y) 1)) 0)) (<= (order' nil) (+ (order y) 1)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order' nil)) 0) (> (count (keys (children x)) (key x)) 0)) (<= (order' nil) (key x)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order' nil)) 0) (> (count (keys (children x)) (key y)) 0)) (<= (order' nil) (key y)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order' nil)) 0) (> (count (keys (children x)) (order nil)) 0)) (<= (order' nil) (order nil)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order' nil)) 0) (> (count (keys (children x)) (order x)) 0)) (<= (order' nil) (order x)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order' nil)) 0) (> (count (keys (children x)) (order y)) 0)) (<= (order' nil) (order y)))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order' nil)) 0) (> (count (keys (children x)) (order (sibling x))) 0)) (<= (order' nil) (order (sibling x))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order' nil)) 0) (> (count (keys (children x)) (order (sibling y))) 0)) (<= (order' nil) (order (sibling y))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order' nil)) 0) (> (count (keys (children x)) (order (children x))) 0)) (<= (order' nil) (order (children x))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order' nil)) 0) (> (count (keys (children x)) (order (children y))) 0)) (<= (order' nil) (order (children y))))))
(assert (=> (mleq (msingleton (key x)) (keys (children x))) (=> (and (> (count (msingleton (key x)) (order' nil)) 0) (> (count (keys (children x)) (order' nil)) 0)) (<= (order' nil) (order' nil)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) w1) 0) (> (count (keys (children y)) w1) 0)) (<= w1 w1))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) w1) 0) (> (count (keys (children y)) w2) 0)) (<= w1 w2))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) w1) 0) (> (count (keys (children y)) (+ (order (children x)) 1)) 0)) (<= w1 (+ (order (children x)) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) w1) 0) (> (count (keys (children y)) (+ (order (children y)) 1)) 0)) (<= w1 (+ (order (children y)) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) w1) 0) (> (count (keys (children y)) (+ (order x) 1)) 0)) (<= w1 (+ (order x) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) w1) 0) (> (count (keys (children y)) (+ (order y) 1)) 0)) (<= w1 (+ (order y) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) w1) 0) (> (count (keys (children y)) (key x)) 0)) (<= w1 (key x)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) w1) 0) (> (count (keys (children y)) (key y)) 0)) (<= w1 (key y)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) w1) 0) (> (count (keys (children y)) (order nil)) 0)) (<= w1 (order nil)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) w1) 0) (> (count (keys (children y)) (order x)) 0)) (<= w1 (order x)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) w1) 0) (> (count (keys (children y)) (order y)) 0)) (<= w1 (order y)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) w1) 0) (> (count (keys (children y)) (order (sibling x))) 0)) (<= w1 (order (sibling x))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) w1) 0) (> (count (keys (children y)) (order (sibling y))) 0)) (<= w1 (order (sibling y))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) w1) 0) (> (count (keys (children y)) (order (children x))) 0)) (<= w1 (order (children x))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) w1) 0) (> (count (keys (children y)) (order (children y))) 0)) (<= w1 (order (children y))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) w1) 0) (> (count (keys (children y)) (order' nil)) 0)) (<= w1 (order' nil)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) w2) 0) (> (count (keys (children y)) w1) 0)) (<= w2 w1))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) w2) 0) (> (count (keys (children y)) w2) 0)) (<= w2 w2))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) w2) 0) (> (count (keys (children y)) (+ (order (children x)) 1)) 0)) (<= w2 (+ (order (children x)) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) w2) 0) (> (count (keys (children y)) (+ (order (children y)) 1)) 0)) (<= w2 (+ (order (children y)) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) w2) 0) (> (count (keys (children y)) (+ (order x) 1)) 0)) (<= w2 (+ (order x) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) w2) 0) (> (count (keys (children y)) (+ (order y) 1)) 0)) (<= w2 (+ (order y) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) w2) 0) (> (count (keys (children y)) (key x)) 0)) (<= w2 (key x)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) w2) 0) (> (count (keys (children y)) (key y)) 0)) (<= w2 (key y)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) w2) 0) (> (count (keys (children y)) (order nil)) 0)) (<= w2 (order nil)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) w2) 0) (> (count (keys (children y)) (order x)) 0)) (<= w2 (order x)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) w2) 0) (> (count (keys (children y)) (order y)) 0)) (<= w2 (order y)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) w2) 0) (> (count (keys (children y)) (order (sibling x))) 0)) (<= w2 (order (sibling x))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) w2) 0) (> (count (keys (children y)) (order (sibling y))) 0)) (<= w2 (order (sibling y))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) w2) 0) (> (count (keys (children y)) (order (children x))) 0)) (<= w2 (order (children x))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) w2) 0) (> (count (keys (children y)) (order (children y))) 0)) (<= w2 (order (children y))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) w2) 0) (> (count (keys (children y)) (order' nil)) 0)) (<= w2 (order' nil)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order (children x)) 1)) 0) (> (count (keys (children y)) w1) 0)) (<= (+ (order (children x)) 1) w1))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order (children x)) 1)) 0) (> (count (keys (children y)) w2) 0)) (<= (+ (order (children x)) 1) w2))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order (children x)) 1)) 0) (> (count (keys (children y)) (+ (order (children x)) 1)) 0)) (<= (+ (order (children x)) 1) (+ (order (children x)) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order (children x)) 1)) 0) (> (count (keys (children y)) (+ (order (children y)) 1)) 0)) (<= (+ (order (children x)) 1) (+ (order (children y)) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order (children x)) 1)) 0) (> (count (keys (children y)) (+ (order x) 1)) 0)) (<= (+ (order (children x)) 1) (+ (order x) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order (children x)) 1)) 0) (> (count (keys (children y)) (+ (order y) 1)) 0)) (<= (+ (order (children x)) 1) (+ (order y) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order (children x)) 1)) 0) (> (count (keys (children y)) (key x)) 0)) (<= (+ (order (children x)) 1) (key x)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order (children x)) 1)) 0) (> (count (keys (children y)) (key y)) 0)) (<= (+ (order (children x)) 1) (key y)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order (children x)) 1)) 0) (> (count (keys (children y)) (order nil)) 0)) (<= (+ (order (children x)) 1) (order nil)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order (children x)) 1)) 0) (> (count (keys (children y)) (order x)) 0)) (<= (+ (order (children x)) 1) (order x)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order (children x)) 1)) 0) (> (count (keys (children y)) (order y)) 0)) (<= (+ (order (children x)) 1) (order y)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order (children x)) 1)) 0) (> (count (keys (children y)) (order (sibling x))) 0)) (<= (+ (order (children x)) 1) (order (sibling x))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order (children x)) 1)) 0) (> (count (keys (children y)) (order (sibling y))) 0)) (<= (+ (order (children x)) 1) (order (sibling y))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order (children x)) 1)) 0) (> (count (keys (children y)) (order (children x))) 0)) (<= (+ (order (children x)) 1) (order (children x))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order (children x)) 1)) 0) (> (count (keys (children y)) (order (children y))) 0)) (<= (+ (order (children x)) 1) (order (children y))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order (children x)) 1)) 0) (> (count (keys (children y)) (order' nil)) 0)) (<= (+ (order (children x)) 1) (order' nil)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order (children y)) 1)) 0) (> (count (keys (children y)) w1) 0)) (<= (+ (order (children y)) 1) w1))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order (children y)) 1)) 0) (> (count (keys (children y)) w2) 0)) (<= (+ (order (children y)) 1) w2))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order (children y)) 1)) 0) (> (count (keys (children y)) (+ (order (children x)) 1)) 0)) (<= (+ (order (children y)) 1) (+ (order (children x)) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order (children y)) 1)) 0) (> (count (keys (children y)) (+ (order (children y)) 1)) 0)) (<= (+ (order (children y)) 1) (+ (order (children y)) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order (children y)) 1)) 0) (> (count (keys (children y)) (+ (order x) 1)) 0)) (<= (+ (order (children y)) 1) (+ (order x) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order (children y)) 1)) 0) (> (count (keys (children y)) (+ (order y) 1)) 0)) (<= (+ (order (children y)) 1) (+ (order y) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order (children y)) 1)) 0) (> (count (keys (children y)) (key x)) 0)) (<= (+ (order (children y)) 1) (key x)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order (children y)) 1)) 0) (> (count (keys (children y)) (key y)) 0)) (<= (+ (order (children y)) 1) (key y)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order (children y)) 1)) 0) (> (count (keys (children y)) (order nil)) 0)) (<= (+ (order (children y)) 1) (order nil)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order (children y)) 1)) 0) (> (count (keys (children y)) (order x)) 0)) (<= (+ (order (children y)) 1) (order x)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order (children y)) 1)) 0) (> (count (keys (children y)) (order y)) 0)) (<= (+ (order (children y)) 1) (order y)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order (children y)) 1)) 0) (> (count (keys (children y)) (order (sibling x))) 0)) (<= (+ (order (children y)) 1) (order (sibling x))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order (children y)) 1)) 0) (> (count (keys (children y)) (order (sibling y))) 0)) (<= (+ (order (children y)) 1) (order (sibling y))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order (children y)) 1)) 0) (> (count (keys (children y)) (order (children x))) 0)) (<= (+ (order (children y)) 1) (order (children x))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order (children y)) 1)) 0) (> (count (keys (children y)) (order (children y))) 0)) (<= (+ (order (children y)) 1) (order (children y))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order (children y)) 1)) 0) (> (count (keys (children y)) (order' nil)) 0)) (<= (+ (order (children y)) 1) (order' nil)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order x) 1)) 0) (> (count (keys (children y)) w1) 0)) (<= (+ (order x) 1) w1))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order x) 1)) 0) (> (count (keys (children y)) w2) 0)) (<= (+ (order x) 1) w2))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order x) 1)) 0) (> (count (keys (children y)) (+ (order (children x)) 1)) 0)) (<= (+ (order x) 1) (+ (order (children x)) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order x) 1)) 0) (> (count (keys (children y)) (+ (order (children y)) 1)) 0)) (<= (+ (order x) 1) (+ (order (children y)) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order x) 1)) 0) (> (count (keys (children y)) (+ (order x) 1)) 0)) (<= (+ (order x) 1) (+ (order x) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order x) 1)) 0) (> (count (keys (children y)) (+ (order y) 1)) 0)) (<= (+ (order x) 1) (+ (order y) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order x) 1)) 0) (> (count (keys (children y)) (key x)) 0)) (<= (+ (order x) 1) (key x)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order x) 1)) 0) (> (count (keys (children y)) (key y)) 0)) (<= (+ (order x) 1) (key y)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order x) 1)) 0) (> (count (keys (children y)) (order nil)) 0)) (<= (+ (order x) 1) (order nil)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order x) 1)) 0) (> (count (keys (children y)) (order x)) 0)) (<= (+ (order x) 1) (order x)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order x) 1)) 0) (> (count (keys (children y)) (order y)) 0)) (<= (+ (order x) 1) (order y)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order x) 1)) 0) (> (count (keys (children y)) (order (sibling x))) 0)) (<= (+ (order x) 1) (order (sibling x))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order x) 1)) 0) (> (count (keys (children y)) (order (sibling y))) 0)) (<= (+ (order x) 1) (order (sibling y))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order x) 1)) 0) (> (count (keys (children y)) (order (children x))) 0)) (<= (+ (order x) 1) (order (children x))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order x) 1)) 0) (> (count (keys (children y)) (order (children y))) 0)) (<= (+ (order x) 1) (order (children y))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order x) 1)) 0) (> (count (keys (children y)) (order' nil)) 0)) (<= (+ (order x) 1) (order' nil)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order y) 1)) 0) (> (count (keys (children y)) w1) 0)) (<= (+ (order y) 1) w1))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order y) 1)) 0) (> (count (keys (children y)) w2) 0)) (<= (+ (order y) 1) w2))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order y) 1)) 0) (> (count (keys (children y)) (+ (order (children x)) 1)) 0)) (<= (+ (order y) 1) (+ (order (children x)) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order y) 1)) 0) (> (count (keys (children y)) (+ (order (children y)) 1)) 0)) (<= (+ (order y) 1) (+ (order (children y)) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order y) 1)) 0) (> (count (keys (children y)) (+ (order x) 1)) 0)) (<= (+ (order y) 1) (+ (order x) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order y) 1)) 0) (> (count (keys (children y)) (+ (order y) 1)) 0)) (<= (+ (order y) 1) (+ (order y) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order y) 1)) 0) (> (count (keys (children y)) (key x)) 0)) (<= (+ (order y) 1) (key x)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order y) 1)) 0) (> (count (keys (children y)) (key y)) 0)) (<= (+ (order y) 1) (key y)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order y) 1)) 0) (> (count (keys (children y)) (order nil)) 0)) (<= (+ (order y) 1) (order nil)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order y) 1)) 0) (> (count (keys (children y)) (order x)) 0)) (<= (+ (order y) 1) (order x)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order y) 1)) 0) (> (count (keys (children y)) (order y)) 0)) (<= (+ (order y) 1) (order y)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order y) 1)) 0) (> (count (keys (children y)) (order (sibling x))) 0)) (<= (+ (order y) 1) (order (sibling x))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order y) 1)) 0) (> (count (keys (children y)) (order (sibling y))) 0)) (<= (+ (order y) 1) (order (sibling y))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order y) 1)) 0) (> (count (keys (children y)) (order (children x))) 0)) (<= (+ (order y) 1) (order (children x))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order y) 1)) 0) (> (count (keys (children y)) (order (children y))) 0)) (<= (+ (order y) 1) (order (children y))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (+ (order y) 1)) 0) (> (count (keys (children y)) (order' nil)) 0)) (<= (+ (order y) 1) (order' nil)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (key x)) 0) (> (count (keys (children y)) w1) 0)) (<= (key x) w1))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (key x)) 0) (> (count (keys (children y)) w2) 0)) (<= (key x) w2))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (key x)) 0) (> (count (keys (children y)) (+ (order (children x)) 1)) 0)) (<= (key x) (+ (order (children x)) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (key x)) 0) (> (count (keys (children y)) (+ (order (children y)) 1)) 0)) (<= (key x) (+ (order (children y)) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (key x)) 0) (> (count (keys (children y)) (+ (order x) 1)) 0)) (<= (key x) (+ (order x) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (key x)) 0) (> (count (keys (children y)) (+ (order y) 1)) 0)) (<= (key x) (+ (order y) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (key x)) 0) (> (count (keys (children y)) (key x)) 0)) (<= (key x) (key x)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (key x)) 0) (> (count (keys (children y)) (key y)) 0)) (<= (key x) (key y)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (key x)) 0) (> (count (keys (children y)) (order nil)) 0)) (<= (key x) (order nil)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (key x)) 0) (> (count (keys (children y)) (order x)) 0)) (<= (key x) (order x)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (key x)) 0) (> (count (keys (children y)) (order y)) 0)) (<= (key x) (order y)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (key x)) 0) (> (count (keys (children y)) (order (sibling x))) 0)) (<= (key x) (order (sibling x))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (key x)) 0) (> (count (keys (children y)) (order (sibling y))) 0)) (<= (key x) (order (sibling y))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (key x)) 0) (> (count (keys (children y)) (order (children x))) 0)) (<= (key x) (order (children x))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (key x)) 0) (> (count (keys (children y)) (order (children y))) 0)) (<= (key x) (order (children y))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (key x)) 0) (> (count (keys (children y)) (order' nil)) 0)) (<= (key x) (order' nil)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (key y)) 0) (> (count (keys (children y)) w1) 0)) (<= (key y) w1))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (key y)) 0) (> (count (keys (children y)) w2) 0)) (<= (key y) w2))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (key y)) 0) (> (count (keys (children y)) (+ (order (children x)) 1)) 0)) (<= (key y) (+ (order (children x)) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (key y)) 0) (> (count (keys (children y)) (+ (order (children y)) 1)) 0)) (<= (key y) (+ (order (children y)) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (key y)) 0) (> (count (keys (children y)) (+ (order x) 1)) 0)) (<= (key y) (+ (order x) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (key y)) 0) (> (count (keys (children y)) (+ (order y) 1)) 0)) (<= (key y) (+ (order y) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (key y)) 0) (> (count (keys (children y)) (key x)) 0)) (<= (key y) (key x)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (key y)) 0) (> (count (keys (children y)) (key y)) 0)) (<= (key y) (key y)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (key y)) 0) (> (count (keys (children y)) (order nil)) 0)) (<= (key y) (order nil)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (key y)) 0) (> (count (keys (children y)) (order x)) 0)) (<= (key y) (order x)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (key y)) 0) (> (count (keys (children y)) (order y)) 0)) (<= (key y) (order y)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (key y)) 0) (> (count (keys (children y)) (order (sibling x))) 0)) (<= (key y) (order (sibling x))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (key y)) 0) (> (count (keys (children y)) (order (sibling y))) 0)) (<= (key y) (order (sibling y))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (key y)) 0) (> (count (keys (children y)) (order (children x))) 0)) (<= (key y) (order (children x))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (key y)) 0) (> (count (keys (children y)) (order (children y))) 0)) (<= (key y) (order (children y))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (key y)) 0) (> (count (keys (children y)) (order' nil)) 0)) (<= (key y) (order' nil)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order nil)) 0) (> (count (keys (children y)) w1) 0)) (<= (order nil) w1))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order nil)) 0) (> (count (keys (children y)) w2) 0)) (<= (order nil) w2))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order nil)) 0) (> (count (keys (children y)) (+ (order (children x)) 1)) 0)) (<= (order nil) (+ (order (children x)) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order nil)) 0) (> (count (keys (children y)) (+ (order (children y)) 1)) 0)) (<= (order nil) (+ (order (children y)) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order nil)) 0) (> (count (keys (children y)) (+ (order x) 1)) 0)) (<= (order nil) (+ (order x) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order nil)) 0) (> (count (keys (children y)) (+ (order y) 1)) 0)) (<= (order nil) (+ (order y) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order nil)) 0) (> (count (keys (children y)) (key x)) 0)) (<= (order nil) (key x)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order nil)) 0) (> (count (keys (children y)) (key y)) 0)) (<= (order nil) (key y)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order nil)) 0) (> (count (keys (children y)) (order nil)) 0)) (<= (order nil) (order nil)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order nil)) 0) (> (count (keys (children y)) (order x)) 0)) (<= (order nil) (order x)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order nil)) 0) (> (count (keys (children y)) (order y)) 0)) (<= (order nil) (order y)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order nil)) 0) (> (count (keys (children y)) (order (sibling x))) 0)) (<= (order nil) (order (sibling x))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order nil)) 0) (> (count (keys (children y)) (order (sibling y))) 0)) (<= (order nil) (order (sibling y))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order nil)) 0) (> (count (keys (children y)) (order (children x))) 0)) (<= (order nil) (order (children x))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order nil)) 0) (> (count (keys (children y)) (order (children y))) 0)) (<= (order nil) (order (children y))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order nil)) 0) (> (count (keys (children y)) (order' nil)) 0)) (<= (order nil) (order' nil)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order x)) 0) (> (count (keys (children y)) w1) 0)) (<= (order x) w1))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order x)) 0) (> (count (keys (children y)) w2) 0)) (<= (order x) w2))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order x)) 0) (> (count (keys (children y)) (+ (order (children x)) 1)) 0)) (<= (order x) (+ (order (children x)) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order x)) 0) (> (count (keys (children y)) (+ (order (children y)) 1)) 0)) (<= (order x) (+ (order (children y)) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order x)) 0) (> (count (keys (children y)) (+ (order x) 1)) 0)) (<= (order x) (+ (order x) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order x)) 0) (> (count (keys (children y)) (+ (order y) 1)) 0)) (<= (order x) (+ (order y) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order x)) 0) (> (count (keys (children y)) (key x)) 0)) (<= (order x) (key x)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order x)) 0) (> (count (keys (children y)) (key y)) 0)) (<= (order x) (key y)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order x)) 0) (> (count (keys (children y)) (order nil)) 0)) (<= (order x) (order nil)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order x)) 0) (> (count (keys (children y)) (order x)) 0)) (<= (order x) (order x)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order x)) 0) (> (count (keys (children y)) (order y)) 0)) (<= (order x) (order y)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order x)) 0) (> (count (keys (children y)) (order (sibling x))) 0)) (<= (order x) (order (sibling x))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order x)) 0) (> (count (keys (children y)) (order (sibling y))) 0)) (<= (order x) (order (sibling y))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order x)) 0) (> (count (keys (children y)) (order (children x))) 0)) (<= (order x) (order (children x))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order x)) 0) (> (count (keys (children y)) (order (children y))) 0)) (<= (order x) (order (children y))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order x)) 0) (> (count (keys (children y)) (order' nil)) 0)) (<= (order x) (order' nil)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order y)) 0) (> (count (keys (children y)) w1) 0)) (<= (order y) w1))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order y)) 0) (> (count (keys (children y)) w2) 0)) (<= (order y) w2))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order y)) 0) (> (count (keys (children y)) (+ (order (children x)) 1)) 0)) (<= (order y) (+ (order (children x)) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order y)) 0) (> (count (keys (children y)) (+ (order (children y)) 1)) 0)) (<= (order y) (+ (order (children y)) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order y)) 0) (> (count (keys (children y)) (+ (order x) 1)) 0)) (<= (order y) (+ (order x) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order y)) 0) (> (count (keys (children y)) (+ (order y) 1)) 0)) (<= (order y) (+ (order y) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order y)) 0) (> (count (keys (children y)) (key x)) 0)) (<= (order y) (key x)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order y)) 0) (> (count (keys (children y)) (key y)) 0)) (<= (order y) (key y)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order y)) 0) (> (count (keys (children y)) (order nil)) 0)) (<= (order y) (order nil)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order y)) 0) (> (count (keys (children y)) (order x)) 0)) (<= (order y) (order x)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order y)) 0) (> (count (keys (children y)) (order y)) 0)) (<= (order y) (order y)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order y)) 0) (> (count (keys (children y)) (order (sibling x))) 0)) (<= (order y) (order (sibling x))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order y)) 0) (> (count (keys (children y)) (order (sibling y))) 0)) (<= (order y) (order (sibling y))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order y)) 0) (> (count (keys (children y)) (order (children x))) 0)) (<= (order y) (order (children x))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order y)) 0) (> (count (keys (children y)) (order (children y))) 0)) (<= (order y) (order (children y))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order y)) 0) (> (count (keys (children y)) (order' nil)) 0)) (<= (order y) (order' nil)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (sibling x))) 0) (> (count (keys (children y)) w1) 0)) (<= (order (sibling x)) w1))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (sibling x))) 0) (> (count (keys (children y)) w2) 0)) (<= (order (sibling x)) w2))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (sibling x))) 0) (> (count (keys (children y)) (+ (order (children x)) 1)) 0)) (<= (order (sibling x)) (+ (order (children x)) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (sibling x))) 0) (> (count (keys (children y)) (+ (order (children y)) 1)) 0)) (<= (order (sibling x)) (+ (order (children y)) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (sibling x))) 0) (> (count (keys (children y)) (+ (order x) 1)) 0)) (<= (order (sibling x)) (+ (order x) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (sibling x))) 0) (> (count (keys (children y)) (+ (order y) 1)) 0)) (<= (order (sibling x)) (+ (order y) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (sibling x))) 0) (> (count (keys (children y)) (key x)) 0)) (<= (order (sibling x)) (key x)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (sibling x))) 0) (> (count (keys (children y)) (key y)) 0)) (<= (order (sibling x)) (key y)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (sibling x))) 0) (> (count (keys (children y)) (order nil)) 0)) (<= (order (sibling x)) (order nil)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (sibling x))) 0) (> (count (keys (children y)) (order x)) 0)) (<= (order (sibling x)) (order x)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (sibling x))) 0) (> (count (keys (children y)) (order y)) 0)) (<= (order (sibling x)) (order y)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (sibling x))) 0) (> (count (keys (children y)) (order (sibling x))) 0)) (<= (order (sibling x)) (order (sibling x))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (sibling x))) 0) (> (count (keys (children y)) (order (sibling y))) 0)) (<= (order (sibling x)) (order (sibling y))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (sibling x))) 0) (> (count (keys (children y)) (order (children x))) 0)) (<= (order (sibling x)) (order (children x))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (sibling x))) 0) (> (count (keys (children y)) (order (children y))) 0)) (<= (order (sibling x)) (order (children y))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (sibling x))) 0) (> (count (keys (children y)) (order' nil)) 0)) (<= (order (sibling x)) (order' nil)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (sibling y))) 0) (> (count (keys (children y)) w1) 0)) (<= (order (sibling y)) w1))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (sibling y))) 0) (> (count (keys (children y)) w2) 0)) (<= (order (sibling y)) w2))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (sibling y))) 0) (> (count (keys (children y)) (+ (order (children x)) 1)) 0)) (<= (order (sibling y)) (+ (order (children x)) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (sibling y))) 0) (> (count (keys (children y)) (+ (order (children y)) 1)) 0)) (<= (order (sibling y)) (+ (order (children y)) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (sibling y))) 0) (> (count (keys (children y)) (+ (order x) 1)) 0)) (<= (order (sibling y)) (+ (order x) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (sibling y))) 0) (> (count (keys (children y)) (+ (order y) 1)) 0)) (<= (order (sibling y)) (+ (order y) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (sibling y))) 0) (> (count (keys (children y)) (key x)) 0)) (<= (order (sibling y)) (key x)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (sibling y))) 0) (> (count (keys (children y)) (key y)) 0)) (<= (order (sibling y)) (key y)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (sibling y))) 0) (> (count (keys (children y)) (order nil)) 0)) (<= (order (sibling y)) (order nil)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (sibling y))) 0) (> (count (keys (children y)) (order x)) 0)) (<= (order (sibling y)) (order x)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (sibling y))) 0) (> (count (keys (children y)) (order y)) 0)) (<= (order (sibling y)) (order y)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (sibling y))) 0) (> (count (keys (children y)) (order (sibling x))) 0)) (<= (order (sibling y)) (order (sibling x))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (sibling y))) 0) (> (count (keys (children y)) (order (sibling y))) 0)) (<= (order (sibling y)) (order (sibling y))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (sibling y))) 0) (> (count (keys (children y)) (order (children x))) 0)) (<= (order (sibling y)) (order (children x))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (sibling y))) 0) (> (count (keys (children y)) (order (children y))) 0)) (<= (order (sibling y)) (order (children y))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (sibling y))) 0) (> (count (keys (children y)) (order' nil)) 0)) (<= (order (sibling y)) (order' nil)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (children x))) 0) (> (count (keys (children y)) w1) 0)) (<= (order (children x)) w1))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (children x))) 0) (> (count (keys (children y)) w2) 0)) (<= (order (children x)) w2))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (children x))) 0) (> (count (keys (children y)) (+ (order (children x)) 1)) 0)) (<= (order (children x)) (+ (order (children x)) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (children x))) 0) (> (count (keys (children y)) (+ (order (children y)) 1)) 0)) (<= (order (children x)) (+ (order (children y)) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (children x))) 0) (> (count (keys (children y)) (+ (order x) 1)) 0)) (<= (order (children x)) (+ (order x) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (children x))) 0) (> (count (keys (children y)) (+ (order y) 1)) 0)) (<= (order (children x)) (+ (order y) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (children x))) 0) (> (count (keys (children y)) (key x)) 0)) (<= (order (children x)) (key x)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (children x))) 0) (> (count (keys (children y)) (key y)) 0)) (<= (order (children x)) (key y)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (children x))) 0) (> (count (keys (children y)) (order nil)) 0)) (<= (order (children x)) (order nil)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (children x))) 0) (> (count (keys (children y)) (order x)) 0)) (<= (order (children x)) (order x)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (children x))) 0) (> (count (keys (children y)) (order y)) 0)) (<= (order (children x)) (order y)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (children x))) 0) (> (count (keys (children y)) (order (sibling x))) 0)) (<= (order (children x)) (order (sibling x))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (children x))) 0) (> (count (keys (children y)) (order (sibling y))) 0)) (<= (order (children x)) (order (sibling y))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (children x))) 0) (> (count (keys (children y)) (order (children x))) 0)) (<= (order (children x)) (order (children x))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (children x))) 0) (> (count (keys (children y)) (order (children y))) 0)) (<= (order (children x)) (order (children y))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (children x))) 0) (> (count (keys (children y)) (order' nil)) 0)) (<= (order (children x)) (order' nil)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (children y))) 0) (> (count (keys (children y)) w1) 0)) (<= (order (children y)) w1))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (children y))) 0) (> (count (keys (children y)) w2) 0)) (<= (order (children y)) w2))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (children y))) 0) (> (count (keys (children y)) (+ (order (children x)) 1)) 0)) (<= (order (children y)) (+ (order (children x)) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (children y))) 0) (> (count (keys (children y)) (+ (order (children y)) 1)) 0)) (<= (order (children y)) (+ (order (children y)) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (children y))) 0) (> (count (keys (children y)) (+ (order x) 1)) 0)) (<= (order (children y)) (+ (order x) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (children y))) 0) (> (count (keys (children y)) (+ (order y) 1)) 0)) (<= (order (children y)) (+ (order y) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (children y))) 0) (> (count (keys (children y)) (key x)) 0)) (<= (order (children y)) (key x)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (children y))) 0) (> (count (keys (children y)) (key y)) 0)) (<= (order (children y)) (key y)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (children y))) 0) (> (count (keys (children y)) (order nil)) 0)) (<= (order (children y)) (order nil)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (children y))) 0) (> (count (keys (children y)) (order x)) 0)) (<= (order (children y)) (order x)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (children y))) 0) (> (count (keys (children y)) (order y)) 0)) (<= (order (children y)) (order y)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (children y))) 0) (> (count (keys (children y)) (order (sibling x))) 0)) (<= (order (children y)) (order (sibling x))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (children y))) 0) (> (count (keys (children y)) (order (sibling y))) 0)) (<= (order (children y)) (order (sibling y))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (children y))) 0) (> (count (keys (children y)) (order (children x))) 0)) (<= (order (children y)) (order (children x))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (children y))) 0) (> (count (keys (children y)) (order (children y))) 0)) (<= (order (children y)) (order (children y))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order (children y))) 0) (> (count (keys (children y)) (order' nil)) 0)) (<= (order (children y)) (order' nil)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order' nil)) 0) (> (count (keys (children y)) w1) 0)) (<= (order' nil) w1))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order' nil)) 0) (> (count (keys (children y)) w2) 0)) (<= (order' nil) w2))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order' nil)) 0) (> (count (keys (children y)) (+ (order (children x)) 1)) 0)) (<= (order' nil) (+ (order (children x)) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order' nil)) 0) (> (count (keys (children y)) (+ (order (children y)) 1)) 0)) (<= (order' nil) (+ (order (children y)) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order' nil)) 0) (> (count (keys (children y)) (+ (order x) 1)) 0)) (<= (order' nil) (+ (order x) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order' nil)) 0) (> (count (keys (children y)) (+ (order y) 1)) 0)) (<= (order' nil) (+ (order y) 1)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order' nil)) 0) (> (count (keys (children y)) (key x)) 0)) (<= (order' nil) (key x)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order' nil)) 0) (> (count (keys (children y)) (key y)) 0)) (<= (order' nil) (key y)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order' nil)) 0) (> (count (keys (children y)) (order nil)) 0)) (<= (order' nil) (order nil)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order' nil)) 0) (> (count (keys (children y)) (order x)) 0)) (<= (order' nil) (order x)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order' nil)) 0) (> (count (keys (children y)) (order y)) 0)) (<= (order' nil) (order y)))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order' nil)) 0) (> (count (keys (children y)) (order (sibling x))) 0)) (<= (order' nil) (order (sibling x))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order' nil)) 0) (> (count (keys (children y)) (order (sibling y))) 0)) (<= (order' nil) (order (sibling y))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order' nil)) 0) (> (count (keys (children y)) (order (children x))) 0)) (<= (order' nil) (order (children x))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order' nil)) 0) (> (count (keys (children y)) (order (children y))) 0)) (<= (order' nil) (order (children y))))))
(assert (=> (mleq (msingleton (key y)) (keys (children y))) (=> (and (> (count (msingleton (key y)) (order' nil)) 0) (> (count (keys (children y)) (order' nil)) 0)) (<= (order' nil) (order' nil)))))

(assert (= (count emptymset w1 ) 0))
(assert (= (count emptymset w2 ) 0))
(assert (= (count emptymset (+ (order (children x)) 1) ) 0))
(assert (= (count emptymset (+ (order (children y)) 1) ) 0))
(assert (= (count emptymset (+ (order x) 1) ) 0))
(assert (= (count emptymset (+ (order y) 1) ) 0))
(assert (= (count emptymset (key x) ) 0))
(assert (= (count emptymset (key y) ) 0))
(assert (= (count emptymset (order nil) ) 0))
(assert (= (count emptymset (order x) ) 0))
(assert (= (count emptymset (order y) ) 0))
(assert (= (count emptymset (order (sibling x)) ) 0))
(assert (= (count emptymset (order (sibling y)) ) 0))
(assert (= (count emptymset (order (children x)) ) 0))
(assert (= (count emptymset (order (children y)) ) 0))
(assert (= (count emptymset (order' nil) ) 0))

(assert (>= (count (keys y) w1) 0))
(assert (>= (count (munion (keys x) (keys y)) w1) 0))

(define (unroll-binomial-heap (arg0 Loc))
  (or
    (= arg0 nil)
    (and
      (not (= arg0 nil))
      (>= (order arg0) 0)
      (binomial-tree arg0)
      (binomial-heap (sibling arg0))
      (> (order arg0) (order (sibling arg0)))
    )
))

(define (unroll-binomial-heap' (arg0 Loc))
  (or
    (= arg0 nil)
    (and
      (not (= arg0 nil))
      (>= (order arg0) 0)
      (binomial-tree' arg0)
      (binomial-heap' (sibling' arg0))
      (> (order' arg0) (order' (sibling' arg0)))
    )
))

(define (unroll-neg-binomial-heap' (arg0 Loc))
  (not (or
    (= arg0 nil)
    (and
      (not (= arg0 nil))
      (>= (order arg0) 0)
      (binomial-tree' arg0)
      (binomial-heap' (sibling' arg0))
      (> (order' arg0) (order' (sibling' arg0)))
    )
)))

(define (unroll-binomial-tree (arg0 Loc))
  (or
    (and
      (= (children arg0) nil)
      (= (order arg0) 0)
    )
    (and
      (not (= (children arg0) nil))
      (binomial-heap (children arg0))
      (full-list (children arg0))
      (> (order arg0) 0)
      (= (order arg0) (+ (order (children arg0)) 1))
      (mleq (msingleton (key arg0)) (keys (children arg0)))
    )
))

(define (unroll-binomial-tree' (arg0 Loc))
  (or
    (and
      (= (children' arg0) nil)
      (= (order' arg0) 0)
    )
    (and
      (not (= (children' arg0) nil))
      (binomial-heap' (children' arg0))
      (full-list' (children' arg0))
      (> (order' arg0) 0)
      (= (order' arg0) (+ (order' (children' arg0)) 1))
      (mleq (msingleton (key arg0)) (keys' (children' arg0)))
    )
))

(define (unroll-neg-binomial-tree' (arg0 Loc))
  (not (or
    (and
      (= (children' arg0) nil)
      (= (order' arg0) 0)
    )
    (and
      (not (= (children' arg0) nil))
      (binomial-heap' (children' arg0))
      (full-list' (children' arg0))
      (> (order' arg0) 0)
      (= (order' arg0) (+ (order' (children' arg0)) 1))
      (or
         (mleq (msingleton (key arg0)) (keys' (children' arg0)))
         (not (< w1 w2))
         (= (count (keys' (children' arg0)) w1) 0)
         (= (count (msingleton (key arg0)) w2) 0)
      )
    )
)))

(define (unroll-full-list (arg0 Loc))
  (or
    (= arg0 nil)
    (and
      (not (= arg0 nil))
      (full-list (sibling arg0))
      (= (order arg0) (+ (order (sibling arg0)) 1))
    )
))

(define (unroll-full-list' (arg0 Loc))
  (or
    (= arg0 nil)
    (and
      (not (= arg0 nil))
      (full-list' (sibling' arg0))
      (= (order' arg0) (+ (order' (sibling' arg0)) 1))
    )
))

(define (unroll-neg-full-list' (arg0 Loc))
  (not (or
    (= arg0 nil)
    (and
      (not (= arg0 nil))
      (full-list' (sibling' arg0))
      (= (order' arg0) (+ (order' (sibling' arg0)) 1))
    ))
))

(define (unroll-keys (arg0 Loc))
  (or
    (and 
      (= arg0 nil)
      (meq (keys arg0) emptymset)
    )
    (and
      (not (= arg0 nil))
      (meq (keys arg0) (munion (munion (msingleton (key arg0)) (keys (children arg0))) (keys (sibling arg0))))
    )
))

(define (unroll-keys' (arg0 Loc))
  (or
    (and 
      (= arg0 nil)
      (meq (keys' arg0) emptymset)
    )
    (and
      (not (= arg0 nil))
      (meq (keys' arg0) (munion (munion (msingleton (key arg0)) (keys' (children' arg0))) (keys' (sibling' arg0))))
    )
))



(define (precondition (arg0 Loc) (arg1 Loc))
  (and
     (binomial-heap arg0)
     (binomial-heap arg1)
  )
)

(define (postcondition (arg0 Loc) (arg1 Loc) (arg2 Loc))
  (and
     (binomial-heap arg2)
     (meq (keys arg2) (munion (keys arg0) (keys arg1)))
     (or
        (and
          (= (order arg0) (order arg1))
          (= arg0 nil)
          (= (order arg2) (order arg0))
        )
        (and
          (= (order arg0) (order arg1))
          (not (= arg0 nil))
          (= (order arg2) (+ (order arg0) 1))
        )
        (and
          (< (order arg0) (order arg1))
          (= (order arg2) (order arg1))
        )
        (and
          (< (order arg0) (order arg1))
          (= (order arg2) (+ (order arg1) 1))
        )
        (and
          (> (order arg0) (order arg1))
          (= (order arg2) (order arg0))
        )
        (and
          (> (order arg0) (order arg1))
          (= (order arg2) (+ (order arg0) 1))
        )
     )
  )
)

(define (negpostcondition (arg0 Loc) (arg1 Loc) (arg2 Loc))
  (or
     (not (binomial-heap arg2))
     (and
       (not (meq (keys arg2) (munion (keys arg0) (keys arg1))))
       (not (= (count (keys arg2) w1) (count (munion (keys arg0) (keys arg1)) w1)))
     )
     (not (or
        (and
          (= (order arg0) (order arg1))
          (= arg0 nil)
          (= (order arg2) (order arg0))
        )
        (and
          (= (order arg0) (order arg1))
          (not (= arg0 nil))
          (= (order arg2) (+ (order arg0) 1))
        )
        (and
          (< (order arg0) (order arg1))
          (= (order arg2) (order arg1))
        )
        (and
          (< (order arg0) (order arg1))
          (= (order arg2) (+ (order arg1) 1))
        )
        (and
          (> (order arg0) (order arg1))
          (= (order arg2) (order arg0))
        )
        (and
          (> (order arg0) (order arg1))
          (= (order arg2) (+ (order arg0) 1))
        )
     ))
  )
)

(define (postcondition' (arg0 Loc) (arg1 Loc) (arg2 Loc))
  (and
     (binomial-heap' arg2)
     (meq (keys' arg2) (munion (keys arg0) (keys arg1)))
     (or
        (and
          (= (order arg0) (order arg1))
          (= arg0 nil)
          (= (order' arg2) (order arg0))
        )
        (and
          (= (order arg0) (order arg1))
          (not (= arg0 nil))
          (= (order' arg2) (+ (order arg0) 1))
        )
        (and
          (< (order arg0) (order arg1))
          (= (order' arg2) (order arg1))
        )
        (and
          (< (order arg0) (order arg1))
          (= (order' arg2) (+ (order arg1) 1))
        )
        (and
          (> (order arg0) (order arg1))
          (= (order' arg2) (order arg0))
        )
        (and
          (> (order arg0) (order arg1))
          (= (order' arg2) (+ (order arg0) 1))
        )
     )
  )
)

(define (negpostcondition' (arg0 Loc) (arg1 Loc) (arg2 Loc))
  (or
     (not (binomial-heap' arg2))
     (and
       (not (meq (keys' arg2) (munion (keys arg0) (keys arg1))))
       (not (= (count (keys' arg2) w1) (count (munion (keys arg0) (keys arg1)) w1)))
     )
     (not (or
        (and
          (= (order arg0) (order arg1))
          (= arg0 nil)
          (= (order' arg2) (order arg0))
        )
        (and
          (= (order arg0) (order arg1))
          (not (= arg0 nil))
          (= (order' arg2) (+ (order arg0) 1))
        )
        (and
          (< (order arg0) (order arg1))
          (= (order' arg2) (order arg1))
        )
        (and
          (< (order arg0) (order arg1))
          (= (order' arg2) (+ (order arg1) 1))
        )
        (and
          (> (order arg0) (order arg1))
          (= (order' arg2) (order arg0))
        )
        (and
          (> (order arg0) (order arg1))
          (= (order' arg2) (+ (order arg0) 1))
        )
     ))
  )
)



; Path1

(declare-fun p1vc1 () Bool)
(assert (iff p1vc1
  (=> 
     (and
       (precondition x y)
       (= x nil)
       (=> (binomial-heap x) (unroll-binomial-heap x))
       (=> (binomial-tree x) (unroll-binomial-tree x))
       (unroll-keys x)
       (=> (binomial-heap y) (unroll-binomial-heap y))
       (=> (binomial-tree y) (unroll-binomial-tree y))
       (unroll-keys y)
     )
     (not (negpostcondition x y y))
  )
))



(assert (not p1vc1))
(check-sat)
(model)